/*
*  Program name:             dotline ver. 1.0
*
*  Program function:         dotted line generate
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            May 6, 1997
*
*  Date of revision:         May 1, 2003 Distribution version by Y. Murata
*
*  Arguments:                1. dot length
*
*  Input:                    JKG data (from stdin)
*
*  Output:                   dotted JKG data (to stdout)
*/

#include <stdio.h>

main(argc, argv)
int	argc ;
char	*argv[] ;
{
	char	hed, txt[500] ;
	double	x1, y1, x2, y2, xd, yd, len, len_n, len_o, l, sqrt() ;

	if (argc > 1) len = atof(argv[1]) ;
	else len = 1.0 ;
	hed = 'l' ;
	while ( (fgets(txt, 500, stdin)) != NULL ) {
	  if (txt[0] == 'm') {
	    sscanf(txt, "%*c %lf %lf", &x1, &y1) ;
	    puts(txt) ;
	    hed = 'l' ;
	    len_o = 0.0 ;
	    }
	  else if (txt[0] == 'l') {
	    sscanf(txt, "%*c %lf %lf", &x2, &y2) ;
	    len_n = sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)) ;
	    if (len_o+len_n < len) {
	      printf("%c %lf %lf\n", hed, x2, y2) ;
	      x1 = x2 ;
	      y1 = y2 ;
	      len_o = len_o + len_n ;
	      }
	    else while (len_n > 0) {
	      if (len >= len_o+len_n) {
	        printf("%c %lf %lf\n", hed, x2, y2) ;
	        x1 = x2 ;
	        y1 = y2 ;
	        len_o = len_o + len_n ;
	        break ;
	        }
	      else {
	        l = (len - len_o) / len_n ;
	        xd = (x2 - x1) * l + x1 ;
	        yd = (y2 - y1) * l + y1 ;
	        printf("%c %lf %lf\n", hed, xd, yd) ;
	        if (hed == 'l') hed = 'm' ;
	        else hed = 'l' ;
	        x1 = xd ;
	        y1 = yd ;
	        len_n = len_n - len + len_o ;
	        len_o = 0.0 ;
	        }
	      }
	    }
	  else {
	    puts(txt) ;
	    }
	  }
	return(0) ;
	}
