/*
*  Program name:             inc_lib
*
*  Program function:         Included library routines
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            Jul 31, 1990
*
*  Date of revision:         May 30, 1995 by Y.Murata
*                            May 1, 2003 Distribution version by Y. Murata
*                            July 8, 2003 Modify function p_line by Y. Murata
*/

long	Ixmin, Iymin, Ixmax, Iymax ;				/* window */
long	Dot, Dots, Dote ;					/* line */
unsigned long	Cdot[320][10] ;					/* line */
unsigned long	Pat[MAXP][32] ;					/* pattern */
long 	Ncolor ;						/* color */
unsigned short	Rgb[MAXC][3] ;					/* color */
float	X_old, Y_old ;						/* plot */
float	Scale_c, X_shift, Y_shift, X_scale, Y_scale ;
float	Xb[MAXD], Yb[MAXD] ;
double	F_x0, F_y0, F_xstr, F_xmin, F_ymin, F_scale, F_rad ;
long	Ixop, Iyop, Negx, Negy, Swpxy ;

/* ------------------------------------------------- graphic init ----------- */
void	Plot_Start_Sub()
{
	long	i ;
	void	Color_Default_Set(), Color_Set() ;

	Color_Default_Set() ;
	CurrentColor = 0 ;
	Color_Set(0) ;
	Scale_c = 1.0 ;
	X_shift = 0.0 ;
	Y_shift = 0.0 ;
	X_scale = 1.0 ;
	Y_scale = 1.0 ;
	Ixmin = 0 ;
	Iymin = 0 ;
	Ixmax = Xdots - 1 ;
	Iymax = Ydots - 1 ;
	for (i = 0; i < 32; i++) {
	  Pat[0][i] = 0 ;
	  Pat[1][i] = 0xFFFFFFFF ;
	  Pat[2][i] = 0 ;
	  }
	}
/* ------------------------------------------------- genten set ------------- */
void	setprm_(f_x0, f_y0, f_xstr, f_xmin, f_ymin, f_scale, f_rad)
double	*f_x0, *f_y0, *f_xstr, *f_xmin, *f_ymin, *f_scale, *f_rad ;
{
	F_x0    = *f_x0    ;
	F_y0    = *f_y0    ;
	F_xstr  = *f_xstr  ;
	F_xmin  = *f_xmin  ;
	F_ymin  = *f_ymin  ;
	F_scale = *f_scale ;
	F_rad   = *f_rad   ;
	}
/* ------------------------------------------------- line select ------------ */
void	chgpen_(lwid, lcol, lpat, llen)
long	*lwid, *lcol, *lpat ;
float	*llen ;
{
	long	n, m, ix, iy, iz ;
	void	Color_Set() ;

	Color_Set(*lcol) ;
	if (*lwid != 0) {
	  Dot  = min(*lwid, 159) ;
	  Dots = (Dot - 1) / 2 ;
	  Dote =  Dot / 2 ;
	  n = Dot * Dot / 4 ;
	  for (ix = -Dots; ix <=Dote; ix++) {
	    for (iy = 0; iy < 10; iy++) Cdot[ix+160][iy] = 0 ;
	    for (iy = -Dots; iy <=Dote; iy++) {
	      iz = ix * ix + iy * iy ;
	      if (iz <= n) {
	        iz = (iy+160)/32 ;
	        m = (iy+160)%32 ;
	        Cdot[ix+160][iz] = bitset(Cdot[ix+160][iz], m) ;
	        }
	      }
	    }
	  }
	}
/* ------------------------------------------------------- line plot -------- */
void	plot_(x, y, n)
float	*x, *y ;
long	*n ;
{
	void	p_line() ;
	float	x_new, y_new, xconv(), yconv() ;

	x_new = xconv(*x) ;
	y_new = yconv(*y) ;
	if (*n == 3) {
	  X_old = x_new ;
	  Y_old = y_new ;
	  }
	else if (*n == 2) {
	  p_line(X_old, Y_old, x_new, y_new) ;
	  X_old = x_new ;
	  Y_old = y_new ;
	  }
	}
/* ------------------------------------------------------- window clip ------ */
void	window_(n, xmin, ymin, xmax, ymax)
long	*n ;
float	*xmin, *ymin, *xmax, *ymax ;
{
	float	w, xconv(), yconv() ;

	if (*n == 1) {
	  Ixmin = 0 ;
	  Iymin = 0 ;
	  Ixmax = Xdots - 1 ;
	  Iymax = Ydots - 1 ;
	  }
	else if (*n == 0) {
	  w = *xmin ;
	  Ixmin = (long)xconv(w) ;
	  if (Ixmin < 0      ) Ixmin = 0 ;
	  w = *ymin ;
	  Iymin = (long)yconv(w) ;
	  if (Iymin < 0      ) Iymin = 0 ;
	  w = *xmax ;
	  Ixmax = (long)xconv(w) ;
	  if (Ixmax > Xdots-1) Ixmax = Xdots-1 ;
	  w = *ymax ;
	  Iymax = (long)yconv(w) ;
	  if (Iymax > Ydots-1) Iymax = Ydots-1 ;
	  }
	}
/* --------------------------------------------------- hatch area ----------- */
void	Area_Fill(xpaint, ypaint, npaint, fbkc, fpat, fptc)
long	*npaint, *fbkc, *fpat, *fptc ;
float	*xpaint, *ypaint ;
{
	float	xmin, ymin, xmax, ymax, xc[10000], yc, xconv(), yconv() ;
	long	i, xs, xe, ys, ye, ic, iy, iym, np, cross(), ccol ;
	void	Hatch_Sub(), Color_Set() ;

	np = *npaint ;
	ccol = CurrentColor ;
	xmin =  999999.0 ;
	ymin =  999999.0 ;
	xmax = -999999.0 ;
	ymax = -999999.0 ;

	for (i = 0 ; i < np ; i++) {
	  Xb[i] = xconv(xpaint[i]) ;
	  Yb[i] = yconv(ypaint[i]) ;
	  if (Xb[i]-0.5 == (long)Xb[i]) Xb[i] = Xb[i] + 0.01 ;
	  if (Yb[i]-0.5 == (long)Yb[i]) Yb[i] = Yb[i] + 0.01 ;
	  if (xmin > Xb[i]) xmin = Xb[i] ;
	  if (xmax < Xb[i]) xmax = Xb[i] ;
	  if (ymin > Yb[i]) ymin = Yb[i] ;
	  if (ymax < Yb[i]) ymax = Yb[i] ;
	  }
	if (Xb[0] != Xb[np-1] || Yb[0] != Yb[np-1]) {
	  Xb[np] = Xb[0] ;
	  Yb[np] = Yb[0] ;
	  np++ ;
	  }

	ys = (long)(ymin + 0.5) ;
	ye = (long)(ymax - 0.5) ;
	if (ys < Iymin) ys = Iymin ;
	if (ye > Iymax) ye = Iymax ;
	xs = (long)(xmin + 0.5) ;
	xe = (long)(xmax - 0.5) ;
	if (xs < Ixmin) xs = Ixmin ;
	if (xe > Ixmax) xe = Ixmax ;

	if (ys == ye) {
	  iym = ys % 32 ;
	  Hatch_Sub(*fbkc, *fpat, *fptc, iym, ys, xs, xe) ;
	  }
	else for (iy = ys ; iy <= ye ; iy++) {
	  iym = iy % 32 ;
	  yc = (float)iy + 0.5 ;
	  ic = cross(yc, xc, np, Xb, Yb, 10000L) ;
	  for (i = 0 ; i < ic ; i = i + 2) {
	    xs = (long)(xc[i]   + 0.5) ;
	    xe = (long)(xc[i+1] - 0.5) ;
	    if (xs < Ixmin) xs = Ixmin ;
	    if (xe > Ixmax) xe = Ixmax ;
	    if (xs <= xe) Hatch_Sub(*fbkc, *fpat, *fptc, iym, iy, xs, xe) ;
	    }
	  }
	Color_Set(ccol) ;
	}
/* ------------------------------------------------- hatch pixel set -------- */
void	Hatch_Sub(fbkc, fpat, fptc, iym, iy, xs, xe)
long	fbkc, fpat, fptc, iym, iy, xs, xe ;
{
	long	ix, ixm, labs() ;
	void	pixel(), Color_Set() ;

	if (fbkc != 0) {
	  Color_Set(fbkc) ;
	  for (ix = xs; ix <= xe; ix++) {
	    pixel(ix, iy) ;
	    }
	  }
	if (fpat != 0) {
	  Color_Set(fptc) ;
	  for (ix = xs; ix <= xe; ix++) {
	    ixm = ix % 32 ;
	    if (bitchk(Pat[labs(fpat)][iym], ixm) != 0) pixel(ix, iy) ;
	    }
	  }
	}
/* ------------------------------------------------- cross check ------------ */
long	cross(ys, xcrs, isuu, x, y, limit)
float	ys, xcrs[], x[], y[] ;
long	isuu, limit ;
{
	long	i, icrs, iu1, iu2 ;
	void	sort() ;

	icrs = 0 ;
	if (y[0] > ys) iu1 = 1 ;
	else iu1 = -1 ;
	for (i = 1; i < isuu; i++) {
	  if (y[i] > ys) iu2 = 1 ;
	  else iu2 = -1 ;
	  if (iu1 * iu2 > 0) continue ;
	  iu1 = iu2 ;
	  xcrs[icrs++] = x[i-1] + (x[i] - x[i-1]) *
	  		(ys - y[i-1]) / (y[i] - y[i-1]) ;
	  if (icrs > limit) {
	    fprintf(stderr, " Number of cross point > %ld.\n", limit) ;
	    exit(-1) ;
	    }
	  }
	if(icrs % 2 != 0) {
	  fprintf(stderr, " cross error ys = %f.\n", ys) ;
	  fprintf(stderr, " %d\n", isuu) ;
	  for (i = 0; i < isuu; i++)
	    fprintf(stderr, " %d %f %f\n", i, x[i], y[i]) ;
	  exit(-1) ;
	  }
	sort(xcrs, icrs) ;
	return(icrs) ;
	}
/* ------------------------------------------------- data sort -------------- */
void	sort(x, icrs)
long	icrs ;
float	x[] ;
{
	long	i, j, k, l ;
	float	x2 ;

	for (i = 1; i < icrs; i++) {
	  for (j = 0; j <= i-1; j++) {
	    l = 1 ;
	    if(x[i] < x[j]) {
	      x2 = x[i] ;
	      for (k = i-1; k >= j; k--) x[k+1] = x[k] ;
	      x[j] = x2 ;
	      l = 0 ;
	      break ;
	      }
	    if (l == 0) break ;
	    }
	  }
	}
/* ----------------------------------------------------------- Font_Set -- */
void	pattbl_(pattern_file)
char	*pattern_file ;
{
	FILE	*pattern ;
	char	tx[50] ;
	long	j, k ;
	long	npat ;

	if ((pattern = fopen(pattern_file, "r")) == NULL) {
	  fprintf(stderr, " Can't open pattern file '%s'.\n", pattern_file) ;
	  exit(-1) ;
	  }
	while (1) {
	  if (fgets(tx, 50, pattern) == NULL) break ;
	  if (sscanf(tx, "%d", &npat) != 1 || npat < 0 || npat >= MAXP) {
	    fprintf(stderr, " Pattern number %d in the pattern file was invalid.\n", npat) ;
	    fprintf(stderr, " Text = %s", tx) ;
	    exit(-1) ;
	    }
	  fgets(tx, 50, pattern) ;
	  for (j = 0; j < 32; j++) {
	    fgets(tx, 50, pattern) ;
	    for (k = 2; k < 34; k++) {
	      if (tx[k]=='r' || tx[k]=='*' )
	        Pat[npat][31-j] = bitset(Pat[npat][31-j], k-2) ;
	      else
	        Pat[npat][31-j] = bitclr(Pat[npat][31-j], k-2) ;
	      }
	    }
	  fgets(tx, 50, pattern) ;
	  }
	fclose(pattern) ;

	}
/* ------------------------------------------------------------- Color_Set -- */
void	coltbl_(color_file)
char	*color_file ;
{
	FILE	*color ;
	long	n ;
	int	r, g, b ;
	void	Color_Table_Set() ;

	if ((color = fopen(color_file, "r")) == NULL) {
	  fprintf(stderr, " Can't open color file '%s'.\n", color_file) ;
	  exit(-1) ;
	  }
	while (fscanf(color, "%ld %d %d %d", &n, &r, &g, &b) == 4) {
	  if (n >= 0 && n < MAXC) {
	    Rgb[n][0] = r ;
	    Rgb[n][1] = g ;
	    Rgb[n][2] = b ;
	    Ncolor = max(Ncolor, n+1) ;
	    }
	  }
	fclose(color) ;
	Color_Table_Set() ;
	}
/* ------------------------------------------------- zahyou henkan  --------- */
float	xconv(x)
float	x ;
{
	float	xx ;
	/* xx = x * Scale_c * Xscl + X0 ; */
	xx = x * Xscl + X0 ;
	if ((long)xx != (long)(xx+0.0001)) xx = xx + 0.0001 ;
	return(xx) ;
	}

float	yconv(y)
float	y ;
{
	float	yy ;
	/* yy = y * Scale_c * Yscl + Y0 ; */
	yy = y * Yscl + Y0 ;
	if ((long)yy != (long)(yy+0.0001)) yy = yy + 0.0001 ;
	return(yy) ;
	}

void	conv_r(x, y)
double	*x, *y ;
{
	double	x1, y1, x2, y2 ;
	void	conv1_r() ;

	x1 = (*x - X0) / Xscl ;
	y1 = (*y - Y0) / Yscl ;
	conv1_r(x1, y1, &x2, &y2) ;
	*x = x2 ;
	*y = y2 ;
	}
/* ------------------------------------------------- frame pixel set -------- */
void	pixel_set(ix, iy)
long	ix, iy ;
{
	long	x, y ;
	void	pixel() ;

	if (ix+Dote < Ixmin || ix-Dots > Ixmax ||
	    iy+Dote < Iymin || iy-Dots > Iymax) return ;
	for (x = -Dots; x <= Dote; x++)
	  for (y = -Dots; y <= Dote; y++)
	    if (bitchk(Cdot[x+160][(y+160)/32], (y+160)%32) != 0)
	      pixel(ix+x, iy+y) ;
	}
/* ------------------------------------------------- line write ------------- */
void	p_line(xk, yk, xl, yl)
float	xk, yk, xl, yl ;
{
	float	xlk, ylk, rsq, a, b ;
	long	ix, ixs, ixe, iy, iys, iye ;

	pixel_set((long)xk, (long)yk) ;
	pixel_set((long)xl, (long)yl) ;
	xlk = xl - xk ;
	ylk = yl - yk ;
	rsq = xlk * xlk + ylk * ylk ;
	if (rsq < 0.2499) return ;

	if (fabsf(xlk) < fabsf(ylk)) {
	  a = xlk / ylk ;
	  b = xk ;
	  if (yk < yl) {
	    iys = (long)yk + 1 ;
	    iye = (long)yl ;
	    }
	  else {
	    iys = (long)yl + 1 ;
	    iye = (long)yk ;
	    }
	  for (iy = iys; iy < iye; iy++) {
	    ix = (long)(((float)(iy) - yk + 0.5) * a + b) ;
	    pixel_set(ix, iy) ;
	    }
	  }
	else {
	  a = ylk / xlk ;
	  b = yk ;
	  if (xk < xl) {
	    ixs = (long)xk + 1 ;
	    ixe = (long)xl ;
	    }
	  else {
	    ixs = (long)xl + 1 ;
	    ixe = (long)xk ;
	    }
	  for (ix = ixs; ix < ixe; ix++) {
	    iy = (long)(((float)(ix) - xk + 0.5) * a + b) ;
	    pixel_set(ix, iy) ;
	    }
	  }
	}
/* ----------------------------------------------- string write ------------- */
void	drwstr_(xx, yy, ssiz, srad, sbal, supd, scol, nc, c)
float	*xx, *yy, *ssiz, *srad, *sbal, *supd ;
char	*c ;
long	*scol, *nc ;
{
	static int ist[]= {   1,   9,  21,  27,  40,  51,  62,  70,
			     79,  84,  88, 104, 110, 115, 125, 140,
			    147, 156, 164, 171, 180, 187, 194, 201,
			    212, 222, 227, 232, 237, 242, 245, 251,
			    264, 278, 288, 295, 302, 311, 322, 336,
			    350, 359, 365, 371, 377, 383, 390, 397,
			    401, 406, 410, 416, 424, 430, 442, 447,
			    454, 459, 465, 475, 485, 490, 497, 506,
			    506, 520, 530, 538, 548, 558, 564, 576,
			    583, 593, 599, 604, 607, 611, 615, 617,
			    626, 637, 642, 647, 657, 664, 673, 683,
			    693, 699, 707, 716, 722, 726, 737, 740,
			    742, 744, 754, 760, 767, 770, 775, 779,
			    785, 789, 792, 798, 814, 816, 819, 831,
			    840, 845, 851, 862, 866, 873, 882, 886,
			    898, 909, 919, 927, 943, 947, 951, 959,
			    959, 965, 969, 977, 983, 989, 994,1000,
			   1005,1013,1017,1022,1029,1037,1043,1050,
			   1055,1062,1069,1077,1084,1088,1093,1097,
			   1103,1112,1115,1118,1121,1126,1132,1137,
			   1139,1144,1147,1155,1160,1166,1171,1177,
			   1185,1190,1195,1199,1205,1211,1217,1224,
			   1231,1237,1241,1248,1254,1260,1265,1270,
			   1276,1283,1287,1292,1298,1304,1308,1313,
			   1313,1321,1333,1341,1348,1355,1360,1371,
			   1377,1383,1395,1400,1405,1409,1413,1415,
			   1421,1428,1434,1437,1442,1446,1455,1462,
			   1473,1482,1486,1498,1504,1508,1514,1517,
			   1519,1521,1533,1537,1543,1546,1551,1555,
			   1560,1564,1567,1573,1583,1585,1590,1603,
			   1612,1617,1625,1638,1642,1651,1661,1666,
			   1682,1694,1706,1712,1723,1730,1734,1744} ;
	static	char buf[] = {
  0xe7,0x43,0x32,0x23,0x25,0x36,0x46,0x62,0xa0,0x32,0x36,0x47,0x57,0x66,0x55,
  0x64,0x53,0x33,0xb5,0x55,0xa2,0x67,0x96,0x27,0x37,0x52,0xc5,0x35,0x24,0x23,
  0x32,0x42,0x53,0x54,0x45,0x37,0x38,0x49,0x69,0xe3,0x52,0x32,0x23,0x34,0x25,
  0x36,0x56,0x65,0xd4,0x34,0xb6,0x25,0x24,0x33,0x53,0x64,0x65,0x56,0x36,0xd8,
  0x31,0xa5,0x37,0x47,0x56,0x53,0x42,0x45,0x69,0xa6,0x35,0x33,0xb5,0x46,0x56,
  0x65,0x61,0x70,0xb6,0x46,0x33,0x42,0x53,0xa2,0x48,0x62,0x22,0xa8,0x68,0xc8,
  0x47,0x37,0x26,0x24,0x33,0x53,0x64,0x66,0x57,0x47,0x42,0xa2,0x62,0x92,0x32,
  0xa2,0x28,0x68,0x57,0xa2,0x48,0x62,0xd2,0x72,0xa2,0x42,0xb2,0x38,0xa8,0x78,
  0xe8,0x62,0xd2,0x72,0xb2,0x23,0x27,0x38,0x58,0x67,0x63,0x52,0x32,0xb4,0x36,
  0xb5,0x55,0xd6,0x54,0xe3,0x62,0x22,0x55,0x28,0x68,0x67,0xb2,0x52,0xc2,0x47,
  0x38,0x27,0xc7,0x58,0x67,0xa7,0x35,0x22,0x66,0xc4,0x43,0x52,0x62,0xa7,0x38,
  0x48,0x56,0x62,0xd6,0x22,0xb6,0x32,0x20,0xb3,0x42,0x52,0x63,0xe6,0x62,0xa6,
  0x35,0x22,0x32,0x65,0x66,0x57,0xb2,0x23,0x36,0x56,0x65,0x52,0x32,0xb2,0x36,
  0xa6,0x66,0xd6,0x54,0x62,0xc2,0x33,0x37,0x48,0x58,0x67,0x63,0x52,0x42,0xb5,
  0x65,0xa0,0x31,0x35,0x46,0x56,0x65,0x64,0x53,0x43,0x34,0xc3,0x48,0x37,0x57,
  0x48,0xc8,0x43,0x34,0x54,0x43,0xf5,0x25,0x36,0x34,0x25,0x95,0x65,0x56,0x54,
  0x65,0x9a,0x7a,0x6b,0xa7,0x67,0xa5,0x65,0xa3,0x63,0xa8,0x68,0xc8,0x42,0xa6,
  0x36,0x34,0x43,0x54,0x56,0x66,0xa2,0x62,0xa3,0x22,0x32,0x34,0x25,0x27,0x38,
  0x58,0x67,0x65,0x54,0x52,0x62,0x63,0xc6,0x55,0x53,0x42,0x32,0x23,0x25,0x36,
  0x66,0x77,0xa5,0x36,0x66,0xd6,0x45,0x43,0x52,0xa7,0x36,0x33,0x42,0x52,0x63,
  0x67,0xa6,0x35,0x34,0x43,0x54,0x55,0x66,0xd8,0x31,0xb7,0x25,0x23,0x32,0x43,
  0x45,0xc3,0x52,0x63,0x65,0x57,0xa7,0x46,0x56,0x57,0x47,0x26,0x35,0x55,0xb5,
  0x24,0x33,0x54,0x63,0x52,0xa7,0x28,0x68,0x67,0xb6,0x34,0xb5,0x55,0xd6,0x54,
  0xa3,0x22,0x62,0x63,0xa6,0x56,0x57,0x47,0x23,0x32,0x53,0x62,0x51,0xa3,0x26,
  0x37,0x57,0x66,0x63,0xa7,0x24,0x33,0x53,0x64,0x67,0xe7,0x37,0x26,0x24,0x33,
  0x63,0xa7,0x57,0x66,0x64,0x53,0x23,0xda,0x49,0x47,0x36,0x45,0x43,0x52,0xba,
  0x49,0x47,0x56,0x45,0x43,0x32,0xa7,0x42,0x67,0x27,0xa2,0x27,0x67,0x62,0x22,
  0xb2,0x39,0xa7,0x47,0xb2,0x39,0xa7,0x47,0xa4,0x44,0xb3,0x39,0xa8,0x48,0xa6,
  0x46,0xa4,0x44,0xa7,0x49,0xc8,0x28,0xa9,0x47,0x97,0x39,0xb8,0x18,0x99,0x37,
  0xc7,0x69,0xe8,0x48,0xc9,0x67,0xb7,0x28,0x39,0x48,0x37,0x97,0x37,0xc8,0x59,
  0x56,0xc6,0x66,0xa8,0x39,0x48,0x26,0x46,0xa9,0x49,0x38,0x47,0x36,0x27,0x98,
  0x29,0x26,0xa5,0x49,0xc7,0x58,0x67,0x45,0x65,0x94,0x25,0x22,0xc2,0x33,0x34,
  0x45,0x54,0x53,0x42,0xa4,0x35,0x44,0x22,0x42,0xa3,0x44,0x35,0x24,0x23,0x32,
  0x43,0xb2,0x39,0xe9,0x25,0xb5,0x46,0x56,0x65,0x62,0xa6,0x37,0x57,0x66,0x64,
  0x62,0xe4,0x55,0x35,0x24,0x23,0x32,0x52,0x63,0xa2,0x29,0xa5,0x36,0x56,0x65,
  0x63,0x52,0x32,0x23,0xe6,0x57,0x37,0x26,0x23,0x32,0x52,0x63,0xe9,0x62,0xe3,
  0x52,0x32,0x23,0x25,0x36,0x56,0x65,0xa4,0x65,0x66,0x57,0x37,0x26,0x23,0x32,
  0x52,0x63,0xc2,0x48,0x59,0x69,0xa6,0x66,0xa1,0x30,0x50,0x61,0x66,0x57,0x37,
  0x26,0x24,0x33,0x53,0x64,0xa2,0x29,0xa5,0x36,0x56,0x65,0x62,0xb8,0x39,0x49,
  0x48,0x38,0xb6,0x46,0x42,0xb2,0x52,0x95,0x26,0x36,0x55,0x65,0x76,0xb2,0x33,
  0x43,0x42,0x32,0xe7,0x25,0x63,0xd9,0x48,0x43,0x52,0xa5,0x65,0xc7,0x43,0xc9,
  0x42,0xe2,0x28,0x39,0x48,0x25,0x23,0x32,0x42,0x64,0xc8,0x49,0x59,0x58,0x48,
  0xc6,0x56,0x51,0x40,0x30,0x21,0xa9,0x22,0xe6,0x24,0x62,0xb9,0x49,0x42,0xb2,
  0x52,0xa2,0x27,0xa6,0x37,0x46,0x57,0x66,0x62,0xc6,0x42,0xa2,0x27,0xa6,0x37,
  0x57,0x66,0x62,0xb2,0x23,0x26,0x37,0x57,0x66,0x63,0x52,0x32,0xa0,0x27,0xa6,
  0x37,0x57,0x66,0x64,0x53,0x33,0x24,0xe0,0x67,0xe6,0x57,0x37,0x26,0x24,0x33,
  0x53,0x64,0xa2,0x27,0xa6,0x37,0x57,0x66,0xc4,0x59,0x49,0x44,0xc3,0x32,0x42,
  0x43,0xc2,0x46,0x29,0xe9,0x46,0xb5,0x55,0xb4,0x54,0xa4,0x66,0xe4,0x26,0xc7,
  0x43,0xb9,0x48,0x43,0x32,0xc6,0x36,0x37,0x47,0x46,0xc3,0x33,0x34,0x44,0x43,
  0x32,0xa6,0x66,0x64,0xa5,0x65,0xa2,0x69,0xa3,0x32,0x52,0x63,0x64,0x25,0x26,
  0x37,0x57,0x66,0xa6,0x66,0xc9,0x43,0x52,0x62,0xa7,0x23,0x32,0x52,0x63,0xe2,
  0x67,0xa7,0x42,0x67,0xa7,0x32,0x45,0x52,0x67,0xa2,0x67,0xa7,0x62,0x90,0x20,
  0x31,0x67,0xa7,0x43,0xa7,0x67,0x22,0x62,0xa3,0x47,0x63,0xc3,0x33,0x34,0x44,
  0x43,0x32,0xa2,0x69,0xc8,0x38,0x27,0x26,0x36,0x47,0x48,0xe5,0x55,0x44,0x43,
  0x53,0x64,0x65,0x91,0x71,0xa7,0x65,0x23,0xa7,0x28,0x39,0x59,0x68,0x67,0x45,
  0x44,0xc3,0x42,0x32,0x43,0xb2,0x23,0x25,0x36,0x46,0x55,0x53,0x42,0x32,0xb5,
  0x46,0x42,0xb2,0x52,0xa5,0x36,0x46,0x55,0x22,0x52,0xa5,0x36,0x46,0x55,0x44,
  0x34,0xc4,0x53,0x42,0x32,0x23,0xc2,0x46,0x23,0x53,0xd6,0x26,0x24,0x44,0x53,
  0x42,0x22,0xc6,0x35,0x23,0x32,0x42,0x53,0x44,0x34,0x23,0xa5,0x26,0x56,0x32,
  0xb4,0x23,0x32,0x42,0x53,0x44,0x34,0x25,0x36,0x46,0x55,0x44,0xa3,0x32,0x42,
  0x53,0x55,0x46,0x36,0x25,0x34,0x44,0x55,0xb6,0x37,0x47,0x46,0x36,0xb3,0x34,
  0x44,0x43,0x33,0xb2,0x39,0xa7,0x67,0xd9,0x52,0xe4,0x24,0xd5,0x57,0x47,0x36,
  0x34,0x44,0x55,0x64,0x67,0x58,0x38,0x27,0x24,0x33,0x53,0x64,0xc6,0x39,0x59,
  0x46,0xa6,0x66,0xe4,0x24,0xb7,0x39,0x49,0x37,0xd7,0x59,0x69,0x57,0xa7,0x67,
  0x45,0xc6,0x44,0x32,0xa4,0x68,0xc6,0x42,0xc8,0x47,0xa5,0x27,0x67,0x65,0x53,
  0x32,0xa7,0x67,0xc7,0x42,0xa2,0x62,0xa2,0x56,0xe6,0x26,0xd8,0x52,0xa2,0x48,
  0xa6,0x66,0x52,0xa4,0x65,0xd7,0x26,0xb8,0x52,0xa5,0x37,0x67,0x54,0x32,0xa4,
  0x35,0x38,0xb6,0x66,0xd6,0x54,0x42,0xa7,0x67,0x62,0x22,0xb2,0x33,0x43,0x42,
  0x32,0xb4,0x38,0xa6,0x66,0xd8,0x54,0x42,0xa2,0x32,0x53,0x65,0xc6,0x27,0xa5,
  0x44,0xa2,0x55,0x67,0x27,0xc4,0x62,0xa5,0x66,0x54,0xb8,0x33,0x42,0x62,0xa7,
  0x35,0xe7,0x54,0x32,0xb2,0x54,0x67,0x37,0x25,0xb5,0x54,0xb2,0x44,0x46,0xd7,
  0x26,0xa5,0x65,0xa5,0x27,0xc7,0x45,0xe7,0x65,0x53,0x32,0xa7,0x57,0xe5,0x25,
  0xc5,0x43,0x32,0xb2,0x38,0xb5,0x64,0xa2,0x44,0x48,0xa6,0x66,0xa7,0x57,0xa2,
  0x62,0xa2,0x55,0x67,0x27,0xb5,0x53,0xc8,0x47,0xa7,0x67,0x23,0xc5,0x42,0xc5,
  0x63,0xe8,0x55,0x22,0xd7,0x37,0x33,0xb2,0x52,0x56,0xa2,0x35,0x37,0xd7,0x62,
  0xe6,0x25,0xa7,0x23,0x32,0x62,0xa7,0x67,0x65,0x53,0x32,0xa5,0x65,0xd4,0x44,
  0x45,0x55,0x54,0xa5,0x37,0x62,0xa2,0x34,0xa6,0x66,0xc8,0x42,0xd4,0x62,0xa7,
  0x67,0x43,0xb4,0x52,0xa7,0x66,0xe4,0x25,0xa3,0x62,0xc8,0x22,0x53,0xc4,0x62,
  0xa2,0x44,0x56,0x58,0xb6,0x63,0xa7,0x57,0xe5,0x25,0xb7,0x33,0x42,0x62,0xa5,
  0x67,0x55,0xb8,0x52,0xb7,0x57,0x42,0xa2,0x62,0xc2,0x34,0x43,0x42,0xa2,0x62,
  0x67,0x27,0xb5,0x65,0xb2,0x53,0x65,0x25,0xa7,0x57,0xb5,0x37,0xe7,0x65,0x53,
  0x32,0xa2,0x35,0x37,0xc7,0x42,0x53,0x65,0xb2,0x53,0x65,0x67,0x27,0xa5,0x65,
  0xb2,0x43,0x44,0xb5,0x55,0x44,0xb3,0x55,0xc4,0x42,0xc5,0x44,0xb3,0x34,0x54,
  0x53,0x42,0xb4,0x54,0xc4,0x42,0xb2,0x52,0xa2,0x44,0xa4,0x54,0xc5,0x42,0xa3,
  0x54,0x43,0xb4,0x42,0xb4,0x44,0x42,0xa2,0x52,0xb2,0x52,0x54,0x34,0xb3,0x53,
  0xb4,0x33,0xc3,0x44,0xd4,0x53,0x42,0xa8,0x22,0x43,0x65,0xa2,0x27,0x67,0x62,
  0x22,0xa5,0x27,0x67,0x65,0x53,0x32,0xa7,0x46,0xe5,0x53,0x32,0x22,0xb5,0x27,
  0xb7,0x45,0xb5,0x26,0x37,0x46,0x35,0xa2,0x28,0x39,0x59,0x68,0x62,0xa5,0x65,
  0xa2,0x29,0x59,0x68,0x67,0x56,0x26,0xd6,0x65,0x63,0x52,0x22,0xe8,0x59,0x39,
  0x28,0x23,0x32,0x52,0x63,0xa2,0x29,0x59,0x68,0x63,0x52,0x22,0xa2,0x29,0x69,
  0xd6,0x26,0xa2,0x62,0xa2,0x29,0x69,0xd6,0x26,0xc5,0x75,0xe5,0x63,0x52,0x32,
  0x23,0x28,0x39,0x59,0x68,0xa2,0x29,0xa6,0x66,0xe9,0x62,0xb9,0x59,0xc9,0x42,
  0xb2,0x52,0x96,0x27,0x37,0x56,0x66,0x77,0xf5,0x64,0x54,0x35,0x25,0x14,0xc2,
  0x32,0x33,0x43,0x42,0xa3,0x63,0xe4,0x26,0x68,0xe9,0x39,0x32,0x62,0xa4,0x64,
  0xc6,0x42,0xa9,0x62,0xa6,0x66,0xc8,0x44,0xa3,0x63,0xa3,0x32,0x42,0x53,0x59,
  0xc9,0x69,0xa2,0x29,0xe9,0x25,0xb6,0x62,0xa9,0x22,0x62,0xa2,0x29,0x45,0x69,
  0x62,0xa2,0x29,0x62,0x69,0xb2,0x23,0x28,0x39,0x59,0x68,0x63,0x52,0x32,0xa2,
  0x29,0x59,0x68,0x67,0x56,0x26,0xb2,0x23,0x28,0x39,0x59,0x68,0x63,0x52,0x32,
  0xc4,0x62,0xa2,0x29,0x59,0x68,0x67,0x56,0x26,0xc6,0x62,0xa4,0x32,0x5a,0x7a,
  0xa4,0x33,0x53,0x64,0x65,0x26,0x27,0x38,0x58,0x67,0xc9,0x42,0xa2,0x47,0x62,
  0x15,0x75,0x22,0xa2,0x52,0x59,0x29,0xb2,0x58,0xe6,0x26,0xa4,0x64,0xa7,0x25,
  0x65,0xa4,0x64,0xa2,0x67,0xa3,0x32,0x52,0x63,0x65,0x56,0x36,0x27,0x28,0x39,
  0x59,0x68,0xc2,0x49,0xa9,0x69,0xa9,0x23,0x32,0x52,0x63,0x69,0xa9,0x42,0x69,
  0xa9,0x32,0x46,0x52,0x69,0xa2,0x69,0xa9,0x62,0xc2,0x46,0x29,0xc6,0x69,0xa9,
  0x69,0x22,0x62,0xa7,0x43,0x67,0xc3,0x33,0x34,0x44,0x43,0x32,0xf7,0x67,0x44,
  0x34,0x25,0x26,0x37,0x47,0x64,0x74,0x9a,0x7a,0xa8,0x66,0x24,0xa3,0x63,0xb4,
  0x24,0x15,0x16,0x27,0x37,0x54,0x64,0x75,0x76,0x67,0x57,0x34,0xd2,0x42,0x33,
  0x38,0x49,0x59,0x68,0x63,0x52,0xb8,0x49,0x42,0xb2,0x52,0xa8,0x39,0x59,0x68,
  0x66,0x23,0x22,0x62,0xa8,0x39,0x59,0x68,0x67,0x56,0x36,0xd6,0x65,0x63,0x52,
  0x32,0x23,0xd2,0x59,0x24,0x64,0xa3,0x32,0x52,0x63,0x65,0x56,0x26,0x29,0x69,
  0xe9,0x38,0x25,0x23,0x32,0x52,0x63,0x64,0x55,0x25,0xa8,0x29,0x69,0x43,0x42,
  0xb6,0x27,0x28,0x39,0x59,0x68,0x67,0x56,0x36,0x25,0x23,0x32,0x52,0x63,0x65,
  0x56,0xa3,0x32,0x52,0x63,0x68,0x59,0x39,0x28,0x26,0x35,0x55,0x66,0xc6,0x47,
  0x57,0x56,0x46,0xa5,0x75,0xd4,0x44,0x43,0x53,0x54,0xb9,0x34,0x55,0xb6,0x57,
  0x52,0xa8,0x48,0x66,0x63,0x52,0x32,0x23,0x24,0x35,0x55,0x64,0xf9,0x7a,0x3a,
  0x56,0x22,0x62,0x63,0xa5,0x65,0xe3,0x23,0xa1,0x30,0x40,0x51,0x52,0x39,0x3a,
  0x4b,0x5b,0x6a,0x00} ;

	float	x , y, ax, ay, bx, by, an, bn, x1, y1, ssiz2 ;
	long	n, ich, is, it, i, ii, ip ;
	float	h, a ;
	double	cos(), sin() ;
	long	ccol ;
	void	Color_Set(), plot_() ;
	int	icharx() ;

	ccol = CurrentColor ;
	if (*scol != 0) Color_Set(*scol) ;
	ssiz2 = *ssiz / 72.0 * 2.54 ;
	x = *xx ;
	y = *yy ;
	h = ssiz2 / 7.0 ;
	a = *srad / 57.29578 ;
	if (*sbal != 0.0 || *supd != 0.0) {
	  ax = -((float)(*nc-1) + 0.66666) * (*sbal) * ssiz2 * 6.0 / 7.0 ;
	  ay = -(ssiz2 * (*supd)) ;
	  x = *xx + ax * cos(a) - ay * sin(a) ;
	  y = *yy + ax * sin(a) + ay * cos(a) ;
	  }
	ax = h * cos(a) ;
	ay = h * sin(a) ;
	bx = -ay ;
	by =  ax ;
	for (n = 0; n < *nc; n++) {
	  ich = icharx(c[n]) ;
	  if (ich ==  0) {
	    x = x + ax * 6.0 ;
	    y = y + ay * 6.0 ;
	    continue ;
	    }
	  is = ist[ich-1] ;
	  it = ist[ich+1-1] - 1 ;
	  for (i = is; i <= it; i++) {
	    ii = buf[i-1] ;
	    ip = (ii >> 7) + 2 ;
	    an = (float)(((ii >> 4) & 7) - 2) ;
	    bn = (float)((ii & 15L) - 2) ;
	    x1 = x + an*ax + bn*bx ;
	    y1 = y + an*ay + bn*by ;
	    if (ip == 1) ip = 3 ;
	    plot_(&x1, &y1, &ip) ;
	    }
	  x = x + ax * 6.0 ;
	  y = y + ay * 6.0 ;
	  }
	if (*scol != 0) Color_Set(ccol) ;
	}

int	icharx(a)
char	a ;
{
	static char	tx[93] = {
	   ' ','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	   'p','q','r','s','t','u','v','w','x','y','z','A','B','C','D','E',
	   'F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U',
	   'V','W','X','Y','Z','0','1','2','3','4','5','6','7','8','9','!',
	   '@','#','$','%','^','&','*','(',')','_','+','|','-','=','{','}',
	   '[',']',':',';','"','\'','~','<','>',',','.','?','/'} ;
	static int	inum[93] = {
          64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
          81,   82,   83,   84,   85,   86,   87,   88,   89,   98,
          99,  100,  101,  102,  103,  104,  105,  193,  194,  195,
         196,  197,  198,  199,  200,  201,  209,  210,  211,  212,
         213,  214,  215,  216,  217,  226,  227,  228,  229,  230,
         231,  232,  233,  240,  241,  242,  243,  244,  245,  246,
         247,  248,  249,   90,  124,  123,  219,  108,  106,   80,
          92,   77,   93,  109,   78,   79,   96,  126,   46,   47,
         205,  221,  122,   94,  127,  125,   74,   76,  110,  107,
          75,  111,   97} ;
	int	i, j ;

	i = 0 ;
	while (i < 93) {
	  if (tx[i] == a) break ;
	  ++i ;
	  }
	if (i == 93) j = inum[70] ;
	else j = inum[i] ;
	return(j) ;
	}
/* ----------------------------------------------- symbol write ------------- */
void	drwmrk_(x, y, mcod, msiz, mcol)
long	*mcod, *mcol ;
float	*x, *y, *msiz ;
{
	static int	markx[22][14] =
	{{-3,-3,-1, 1, 3, 3, 1,-1,-3, 9, 9, 9, 9, 9},
	 {-3, 3, 0,-3, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 3, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 3, 0,-3, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 0, 3, 0,-3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 0, 3,-3, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3,-3, 3, 3,-3, 3, 3,-3, 9, 9, 9, 9, 9, 9},
	 {-3, 3, 0,-3, 3, 0,-3, 3, 0, 0, 0, 9, 9, 9},
	 {-3, 0, 3, 0,-3, 3, 0, 0, 0, 9, 9, 9, 9, 9},
	 {-3,-3,-1, 1, 3, 3, 1,-1,-3,-3, 3, 0, 0, 0},
	 { 0, 0, 0,-3, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 3, 0,-3, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 0,-3,-3, 3, 3, 0, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 0,-3, 0, 3, 0, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 0,-3, 0, 3, 0, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 0,-3, 0, 3, 0, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 0,-1,-3,-3,-1, 1, 3, 3, 1, 0, 9, 9, 9},
	 {-3, 3,-3, 3,-3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 0, 0, 0, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 0,-3, 3, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 3,-3, 3,-3, 0,-1, 1, 9, 9, 9, 9, 9, 9},
	 {-3,-1,-1,-3,-1, 1, 3, 1, 1, 3, 0, 1,-1, 9}} ;
	static int	marky[22][14] =
	{{ 1,-1,-3,-3,-1, 1, 3, 3, 1, 9, 9, 9, 9, 9},
	 {-3,-3, 3,-3, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 0, 0, 3,-3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 3,-3, 0,-3, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0,-3, 0, 3, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 3,-3, 3, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 3,-3,-3, 3, 3,-3, 3,-3, 9, 9, 9, 9, 9, 9},
	 { 3,-3, 0, 0, 0, 0,-3, 3, 0, 3,-3, 9, 9, 9},
	 { 0,-3, 0, 3, 0, 0, 0, 3,-3, 9, 9, 9, 9, 9},
	 { 1,-1,-3,-3,-1, 1, 3, 3, 1, 0, 0, 0, 3,-3},
	 { 3,-3, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 3,-3, 0,-3, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 3, 3,-3,-3, 3, 3, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 3, 0,-3, 0, 3, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0,-3,-3, 3,-3,-3, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 3, 3,-3, 3, 3, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 0, 3, 3, 1,-1,-3,-3,-1, 1, 3, 3, 9, 9, 9},
	 { 3,-3,-3, 3, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 3, 0,-3, 0, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 {-3, 3, 0, 0, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9},
	 { 3, 3,-3,-3,-3, 0, 1,-1, 9, 9, 9, 9, 9, 9},
	 { 3, 1,-1,-3,-1,-1,-3,-1, 1, 3, 0, 1, 1, 9}} ;
	long	ccol, pen, j ;
	float	rx, ry, s ;
	void	Color_Set(), plot_() ;

	if (*mcol != 0) {
		ccol = CurrentColor ;
		Color_Set(*mcol) ;
		}
	if (*mcod < 1 || *mcod > 22) {
		fprintf(stderr, " mcod should be langed in 1 - 22.\n") ;
		return ;
		}
	pen = 3 ;
	s = (float)(*msiz) / 72.0 * 2.54 / 3.0 ;
	for (j = 0; j < 14; j++) {
		if (markx[*mcod-1][j] == 9.0) break ;
		rx = *x + (float)markx[*mcod-1][j] * s ;
		ry = *y + (float)marky[*mcod-1][j] * s ;
		plot_(&rx, &ry, &pen) ;
		pen = 2 ;
		}
	if (*mcol != 0) Color_Set(ccol) ;
	}
