/*
*  Program name:             jkg_arc ver. 1.0
*
*  Program function:         JKG to ARC/INFO generate file
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            May 27, 1991
*
*  Date of revision:         May 1, 2003 Distribution version by Y. Murata
*
*  Arguments:                1: attribute file name
*
*  Input:                    JKG data (from stdin)
*
*  Output:                   ArcInfo generate file (to stdout)
*
*/

#include <stdio.h>
#include <string.h>

main(argc, argv)
int	argc ;
char	*argv[] ;
{
	FILE	*fp ;
	int	n, k=0 ;
	char	hed, txt[500], attr[50] ;
	double	x, y ;

	if (argc != 1) {
		k = 1 ;
		fp = fopen(argv[1], "w") ;
		}
	n = 0 ;
	while ((fgets(txt, 500, stdin)) != NULL) {
		if (txt[0] == '#' && k == 1) {
			strcpy(attr, &txt[2]) ;
			}
		else if (txt[0] == 'l') {
			if (sscanf(txt, "%c %lf %lf", &hed, &x, &y) != 3) {
				fprintf(stderr, " JKG data error.\n") ;
				return(1) ;
				}
			printf("%lf %lf\n", x, y) ;
/*			printf("%d %d\n", (int)x, (int)y) ; */
			}
		else if (txt[0] == 'm') {
			if (n != 0) printf("END\n") ;
			n++ ;
			printf("%d\n", n) ;
			if (k == 1) fprintf(fp, "%5d %s\n", n, attr) ;
			if (sscanf(txt, "%c %lf %lf", &hed, &x, &y) != 3) {
				fprintf(stderr, " JKG data error.\n") ;
				return(-1) ;
				}
			printf("%lf %lf\n", x, y) ;
/*			printf("%d %d\n", (int)x, (int)y) ; */
			}
		}
	printf("END\n") ;
	printf("END\n") ;
	return(0) ;
	}
