/*
*  Program name:             pen_chg  ver. 2.0
*
*  Program function:         JKG data pen change program
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            Jul 31, 1990
*
*  Date of revision:         June 30, 1995 rewrite using C by Y.Murata
*                            May 1, 2003 Distribution version by Y. Murata
*
*  Arguments:                -c old new (change color old to new max 20 pairs)
*                            -w old new (change width old to new max 20 pairs)
*
*  Input:                    JKG data (from stdin)
*
*  Output:                   JKG data (to stdout)
*/

#include <stdio.h>
#include <string.h>

main(argc, argv)
int	argc ;
char	*argv[] ;
{
	int	ncol, old_col[20], new_col[20], nwid, old_wid[20], new_wid[20] ;
	int	i, mode, atoi() ;
	char	txt[500] ;
	long	lwid, lcol ;

	mode = 0 ;
	nwid = 0 ;
	ncol = 0 ;
	for (i = 1; i < argc; i++) {
	  if (!strcmp(argv[i], "-h")) {
	    fprintf(stderr, "pen_chg {-w old new -c old new}\n") ;
	    return(0) ;
	    }
	  else if (!strcmp(argv[i], "-w")) mode = 1 ;
	  else if (!strcmp(argv[i], "-c")) mode = 2 ;
	  else if (mode == 1) {
	    old_wid[nwid] = atoi(argv[i++]) ;
	    new_wid[nwid] = atoi(argv[i]) ;
	    nwid++ ;
	    }
	  else if (mode == 2) {
	    old_col[ncol] = atoi(argv[i++]) ;
	    new_col[ncol] = atoi(argv[i]) ;
	    ncol++ ;
	    }
	  }

	while ((fgets(txt, 500, stdin)) != NULL) {
	  if (txt[0] == 'L') {
	    if (txt[1] == 'w') {
	      sscanf(txt, "%*c%*c %ld", &lwid) ;
	      for (i = 0; i < nwid; i++) {
	        if (lwid == old_wid[i]) {
	          lwid = new_wid[i] ;
	          break ;
	          }
	        }
	      printf("Lw %ld\n", lwid) ;
	      }
	    else if (txt[1] == 'c') {
	      sscanf(txt, "%*c%*c %ld", &lcol) ;
	      for (i = 0; i < ncol; i++) {
	        if (lcol == old_col[i]) {
	          lcol = new_col[i] ;
	          break ;
	          }
	        }
	      printf("Lc %ld\n", lcol) ;
	      }
	    }
	  else printf("%s", txt) ;
	  }
	return(0) ;
	}
