/*
*  Program name:             smooth ver. 1.0
*
*  Program function:         coordinate smoothing
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            Jul 30, 1990
*
*  Date of revision:         May 1, 2003 Distribution version by Y. Murata
*
*  Arguments:                none
*
*  Input:                    JKG data (from stdin)
*
*  Output:                   smoothed JKG data (to stdout)
*/

#include <stdio.h>

main()
{
	char	hed, txt[500] ;
	int	ip ;
	double	dx, dy, x1, y1, x2, y2, x3, y3 ;

	ip = 0 ;
	while ( (fgets(txt, 500, stdin)) != NULL ) {
		if (txt[0] == 'm') {
			if (ip == 2) printf("l %12.2lf %12.2lf\n", x3, y3) ;
			sscanf(txt, "%c %lf %lf", &hed, &x2, &y2) ;
			puts(txt) ;
			ip = 1 ;
			}
		else if (txt[0] == 'l') {
			sscanf(txt, "%c %lf %lf", &hed, &x3, &y3) ;
			if (ip == 1) {
				x1 = x2 ;
				y1 = y2 ;
				x2 = x3 ;
				y2 = y3 ;
				ip = 2 ;
				}
			else {
				dx = (x1 + x2 + x3) / 3.0 ;
				dy = (y1 + y2 + y3) / 3.0 ;
				printf("l %12.2lf %12.2lf\n", dx, dy) ;
				x1 = x2 ;
				y1 = y2 ;
				x2 = x3 ;
				y2 = y3 ;
				}
			}
		else {
			if (ip == 2) printf("l %12.2lf %12.2lf\n", x3, y3) ;
			ip = 0 ;
			puts(txt) ;
			}
		}
	if (ip == 2) printf("l %12.2lf %12.2lf\n", x3, y3) ;
	return(0) ;
	}
