c
      program    BayDelo
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      real*8     w1, w2, dist, eps, wABIC, hyper(maxH)
      integer    i
c
      external   funcs
c -------------------------------------------------------------------- c
      ABIC = 9.0d9
c
      call datred(w1, w2, dist, eps)
      call initul
c
      do i = 1, maxM
        S(i) = 1.0d0
        end do
c
      if (eps .eq. 0.0d0) then
        call MABICS(w1, w2, wABIC, 1)
      else
        hyper(1) = dlog(w1)
        hyper(2) = dlog(w2)
        call simplx(hyper, 2, funcs, dist, eps, wABIC)
        call MABICS(w1min, w2min, wABIC, 1)
        end if
c -------------------------------------------------------------------- c
      stop
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine funcs(nh, hyper, wABIC)
c
      include    'baydelo.def'
c
      integer    nh
      real*8     hyper(maxH), w1, w2, wABIC
c -------------------------------------------------------------------- c
      w1 = dexp(hyper(1))
      w2 = dexp(hyper(2))
c
c     if (w1 .lt. 1.0d-10) w1 = 1.0d-10
c     if (w2 .lt. 1.0d-10) w2 = 1.0d-10
c
      call MABICS(w1, w2, wABIC, 0)
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine MABICS(w1, w2, wABIC, ip)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      real*8     au(maxRM), al(maxRM), ad(maxM)
      real*8     uu(maxRM), ul(maxRM), ud(maxM)
      real*8     b(maxM), r(maxM), p(maxM), ru(maxM), ap(maxM)
      common     /iccg1/ nzu, nzl, iu, il
      common     /iccg2/ au, al, ad, uu, ul, ud, b, r, p, ru, ap
c
      integer    ip, i, j, k
      real*8     w1, w2, wABIC
      real*8     dum, rss, rsr, sigma2, sd, detD, detZ, pi, eps
      data       pi/3.1415926535898d0/
      character  t*150
c -------------------------------------------------------------------- c
      write(6, '(a)') ' '
      write(6, *) ' MABICS start '
c
      call clearZ
      call Zset(1, w1, w2)
c
      call crconv(1, Np+Nprm, 0, au, al)
      call icdcmp(Np+Nprm, nzl, il, al, ad, ul, ud)
      call crconv(1, Np+Nprm, 1, ul, uu)
c
      detZ = 0.0d0
      do i = 1, Np-1
        if (ud(i) .gt. 0.0d0) detZ = detZ - dlog(ud(i))
        end do
      eps = 1.0d-5
      call cg(Np+Nprm, nzu, nzl, iu, il,
     $        au, al, ad, b, eps, S,
     $        uu, ul, ud, r, p, ru, ap)
c
      call DLOerr(rss)
c
      call clearZ
      call calRSR(w1, w2, rsr)
      call Zset(0, w1, w2)
      call crconv(0, Np, 0, au, al)
      call icdcmp(Np, nzl, il, al, ad, ul, ud)
      detD = 0.0d0
      do i = 1, Np-1
        if (ud(i) .gt. 0.0d0) detD = detD - dlog(ud(i))
        end do
c
      write(6, '(a, 2D15.7)') ' Fitness, Smoothness    =', rss, rsr
c
      sigma2 = (rss + rsr) / dfloat(Nd)
      sd = dsqrt(sigma2)
c
      wABIC = dfloat(Nd) * dlog(2.0d0 * pi * sigma2)
     &                 - detD + detZ + dfloat(Nd)
c
      write(6, '(a25, 3D15.7, 2f10.2)')
     &          ' sgm2, detD, detZ, ABIC =', sigma2, detD, detZ, wABIC
c -------------------------------------------------------------------- c
      do i = 1, Np + Nprm
c       write(6, *) i, errS(i), sd
c       errS(i) = errS(i) * sd
        errS(i) = 0.0d0
        end do
c -------------------------------------------------------------------- c
      if (wABIC .lt. ABIC) then
        w1min  = w1
        w2min  = w2
        ABIC   = wABIC
        do i = 1, Nprm
          write(6, '(a, i5, f10.3, 4h +- , f10.3)')
     &       ' Prm = ', i, S(Np+i), errS(Np+i)
          end do
        end if
c -------------------------------------------------------------------- c
      if (ip .eq. 1 .and. DLOout .ne. 'dummy') then
        open(10, file=DLOout)
        rewind(10)
        call DLOwtr(10, sd, rss, w1, w2, wABIC)
        close(10)
        write(6, '(a)') ' '
        end if
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine clearZ
c -------------------------------------------------------------------- c
      include    'baydelo.def'
c
      integer    nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      real*8     au(maxRM), al(maxRM), ad(maxM)
      real*8     uu(maxRM), ul(maxRM), ud(maxM)
      real*8     b(maxM), r(maxM), p(maxM), ru(maxM), ap(maxM)
      common     /iccg1/ nzu, nzl, iu, il
      common     /iccg2/ au, al, ad, uu, ul, ud, b, r, p, ru, ap
c
      integer    ic, ir
c -------------------------------------------------------------------- c
      write(6, *) ' clearZ start '
c
      nzu(0) = 0
      nzl(0) = 0
      do ir = 1, maxM
        nzu(ir) = 0
        nzl(ir) = 0
        ad(ir) = 0.0d0
        ud(ir) = 0.0d0
        b(ir) = 0.0d0
        r(ir) = 0.0d0
        p(ir) = 0.0d0
        ru(ir) = 0.0d0
        ap(ir) = 0.0d0
        end do
      do ic = 1, maxRM
        iu(ic) = 0
        il(ic) = 0
        au(ic) = 0.0d0
        al(ic) = 0.0d0
        uu(ic) = 0.0d0
        ul(ic) = 0.0d0
        end do
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine Zset(iobs, w1, w2)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      real*8     au(maxRM), al(maxRM), ad(maxM)
      real*8     uu(maxRM), ul(maxRM), ud(maxM)
      real*8     b(maxM), r(maxM), p(maxM), ru(maxM), ap(maxM)
      common     /iccg1/ nzu, nzl, iu, il
      common     /iccg2/ au, al, ad, uu, ul, ud, b, r, p, ru, ap
c
      integer    iobs
      real*8     w1, w2
c
      integer    i, j, k, l, j1, j2, j3, j4
      integer    k1, k2
      real*8     w, xymax, x1, y1, x2, y2, x3, y3, x4, y4
      real*8     x12, x23, x31, y21, y32, y13, c
      real*8     x12l, x23l, x31l, y21l, y32l, y13l
      real*8     x12r, x23r, x31r, y21r, y32r, y13r
c -------------------------------------------------------------------- c
      write(6, *) ' Zset start ', w1, w2
c
      if (Np+Nprm .gt. maxM) then
        write(6, *) 'Np+Nprm .gt. maxM'
        stop
        end if
      xymax = Xmax - Xmin
      if (Ymax - Ymin .gt. xymax) xymax = Ymax - Ymin
c                                                      -- Observation --
      if (iobs .eq. 1) then
        do i = 1, Np
          if (No(i) .gt. 0) then
            ad(i) = 1.0d0
            b(i) = Gp(i)
            do j = 1, Nprm
              call seaiu(iobs, i, Np+j, k)
              au(k) = Hp(i, j)
              b(Np+j) = b(Np+j) + Gp(i) * Hp(i, j)
              end do
            end if
          end do
        do i = 1, Nprm
          do j = i, Nprm
            w = 0.0d0
            do k = 1, Np
              w = w + Hp(k, i) * Hp(k, j)
              end do
            if (i .eq. j) then
              ad(Np+i) = w
            else
              call seaiu(iobs, Np+i, Np+j, k)
              au(k) = w
              end if
            end do
          end do
        end if
c                                                            -- Prior --
      do i = 1, Nt
        j1 = Tp(1, i)
        j2 = Tp(2, i)
        j3 = Tp(3, i)
        x1 = (Xp(j1) - Xmin) / xymax
        y1 = (Yp(j1) - Ymin) / xymax
        x2 = (Xp(j2) - Xmin) / xymax
        y2 = (Yp(j2) - Ymin) / xymax
        x3 = (Xp(j3) - Xmin) / xymax
        y3 = (Yp(j3) - Ymin) / xymax
        c = (x1 - x3) * (y1 - y2) - (x1 - x2) * (y1 - y3)
        c = dsqrt(w1 * At(i)) / c
        x12 = (x1 - x2) * c
        x23 = (x2 - x3) * c
        x31 = (x3 - x1) * c
        y21 = (y2 - y1) * c
        y32 = (y3 - y2) * c
        y13 = (y1 - y3) * c
        ad(j1) = ad(j1) + y32 * y32 + x23 * x23
        ad(j2) = ad(j2) + y13 * y13 + x31 * x31
        ad(j3) = ad(j3) + y21 * y21 + x12 * x12
        call seaiu(iobs, j1, j2, k)
        au(k) = au(k) + y32 * y13 + x23 * x31
        call seaiu(iobs, j2, j3, k)
        au(k) = au(k) + y13 * y21 + x31 * x12
        call seaiu(iobs, j3, j1, k)
        au(k) = au(k) + y21 * y32 + x12 * x23
        end do
c
      do i = 1, Nl
        if (Lt(i).eq.0 .or. Rt(i).eq.0) cycle
        j1 = Ls(i)
        j2 = Le(i)
        j3 = Rp(i)
        j4 = Lp(i)
        x1 = (Xp(j1) - Xmin) / xymax
        y1 = (Yp(j1) - Ymin) / xymax
        x2 = (Xp(j2) - Xmin) / xymax
        y2 = (Yp(j2) - Ymin) / xymax
        x3 = (Xp(j3) - Xmin) / xymax
        y3 = (Yp(j3) - Ymin) / xymax
        x4 = (Xp(j4) - Xmin) / xymax
        y4 = (Yp(j4) - Ymin) / xymax
        c = (x1 - x4) * (y1 - y2) - (x1 - x2) * (y1 - y4)
        c = dsqrt(w2 * Wl(i)) / c
        x12r = (x1 - x2) * c
        x23r = (x2 - x4) * c
        x31r = (x4 - x1) * c
        y21r = (y2 - y1) * c
        y32r = (y4 - y2) * c
        y13r = (y1 - y4) * c
        c = (x2 - x3) * (y2 - y1) - (x2 - x1) * (y2 - y3)
        c = dsqrt(w2 * Wl(i)) / c
        x12l = (x2 - x1) * c
        x23l = (x1 - x3) * c
        x31l = (x3 - x2) * c
        y21l = (y1 - y2) * c
        y32l = (y3 - y1) * c
        y13l = (y2 - y3) * c
        ad(j1) = ad(j1) + (y13l - y32r)**2 + (x31l - x23r)**2
        ad(j2) = ad(j2) + (y32l - y13r)**2 + (x23l - x31r)**2
        ad(j3) = ad(j3) + y21l**2 + x12l**2
        ad(j4) = ad(j4) + y21r**2 + x12r**2
        call seaiu(iobs, j1, j2, k)
        au(k) = au(k) + (y13l - y32r) * (y32l - y13r)
     &                + (x31l - x23r) * (x23l - x31r)
        call seaiu(iobs, j1, j3, k)
        au(k) = au(k) + (y13l - y32r) * y21l + (x31l - x23r) * x12l
        call seaiu(iobs, j1, j4, k)
        au(k) = au(k) - (y13l - y32r) * y21r - (x31l - x23r) * x12r
        call seaiu(iobs, j2, j3, k)
        au(k) = au(k) + (y32l - y13r) * y21l + (x23l - x31r) * x12l
        call seaiu(iobs, j2, j4, k)
        au(k) = au(k) - (y32l - y13r) * y21r - (x23l - x31r) * x12r
        call seaiu(iobs, j3, j4, k)
        au(k) = au(k) - y21l * y21r - x12l * x12r
        end do
c                                             -- nzu, nzl, iu, il set --
      call intset(iobs)
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine intset(iobs)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      integer    ni, niu(0:maxM), iu1(maxRM), iu2(maxRM),
     &               nil(0:maxM), il1(maxRM), il2(maxRM)
      common     /iccg1/ nzu, nzl, iu, il
      common     /iccg3/ ni, niu, iu1, iu2, nil, il1, il2
c
      integer    iobs
      integer    i, j, k, www
      data       www/0/
c -------------------------------------------------------------------- c
      do i = 0, Np+Nprm
        nzu(i) = 0
        nzl(i) = 0
        end do
      if (iobs .eq. 1) then
        do i = 1, ni
          nzu(iu1(i)) = i
          iu(i) = iu2(i)
          nzl(il1(i)) = i
          il(i) = il2(i)
          end do
      else
        k = 0
        nzu(0) = 0
        do i = 1, Np
          do j = niu(i-1)+1, niu(i)-Nprm
            k = k + 1
            iu(k) = iu2(j)
            end do
          nzu(i) = k
          end do
        k = 0
        nzl(0) = 0
        do i = 1, Np
          do j = nil(i-1)+1, nil(i)
            k = k + 1
            il(k) = il2(j)
            end do
          nzl(i) = k
          end do
        end if
      do i = 1, Np+Nprm
        if (nzu(i) .eq. 0) nzu(i) = nzu(i-1)
        if (nzl(i) .eq. 0) nzl(i) = nzl(i-1)
        end do
c
c     if (iobs.eq.1 .and. www.eq.0) then
c       call nmsets(Np+Nprm, nzu, nzl, iu, il)
c       www = 1
c       end if
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine initul
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    ni, niu(0:maxM), iu1(maxRM), iu2(maxRM),
     &               nil(0:maxM), il1(maxRM), il2(maxRM)
      common     /iccg3/ ni, niu, iu1, iu2, nil, il1, il2
c
      integer    i, j, j1, j2, j3, j4
c -------------------------------------------------------------------- c
      write(6, *) ' initul start'
      ni = 0
c
      do i = 0, maxM
        niu(i) = 0
        end do
c
      if (Nprm .ne. 0) then
        do i = 1, Np
          do j = 1, Nprm
            call addiu(Np+Nprm, i, Np+j, ni, niu, iu1, iu2)
            end do
          end do
        end if
c
c     do i = 1, Np
c       do j = i, Np
c         call addiu(Np+Nprm, i, j, ni, niu, iu1, iu2)
c         end do
c       end do
c
      do i = 1, Nprm
        do j = i+1, Nprm
          call addiu(Np+Nprm, Np+i, Np+j, ni, niu, iu1, iu2)
          end do
        end do
      do i = 1, Nt
        j1 = Tp(1, i)
        j2 = Tp(2, i)
        j3 = Tp(3, i)
        call addiu(Np+Nprm, j1, j2, ni, niu, iu1, iu2)
        call addiu(Np+Nprm, j2, j3, ni, niu, iu1, iu2)
        call addiu(Np+Nprm, j3, j1, ni, niu, iu1, iu2)
        end do
      do i = 1, Nl
        if (Lt(i).eq.0 .or. Rt(i).eq.0) cycle
        j3 = Lp(i)
        j4 = Rp(i)
        call addiu(Np+Nprm, j3, j4, ni, niu, iu1, iu2)
        end do
      write(6, *) 'maxRM', ni, '/', maxRM, 'used.'
c     do i = 1, np
c       do j = niu(i-1)+1, niu(i)
c         write(3, '(5i6)') i, niu(i)-niu(i-1), j, iu1(j), iu2(j)
c         end do
c       end do
c     call sortul(Np+Nprm, ni, niu, iu1, iu2)
c
      do i = 1, ni
        il1(i) = iu2(i)
        il2(i) = iu1(i)
        end do
      call sortul(Np+Nprm, ni, nil, il1, il2)
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine seaiu(iobs, k1, k2, k)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    ni, niu(0:maxM), iu1(maxRM), iu2(maxRM),
     &               nil(0:maxM), il1(maxRM), il2(maxRM)
      common     /iccg3/ ni, niu, iu1, iu2, nil, il1, il2
c
      integer    iobs, k1, k2, k
      integer    i, j1, j2, j3, j4, kk1, kk2
c -------------------------------------------------------------------- c
      if (k1 .gt. k2) then
        kk1 = k2
        kk2 = k1
      else
        kk1 = k1
        kk2 = k2
        end if
c
      if (kk2 .gt. Np) then
        k = niu(kk1) - (Np+Nprm-kk2)
        return
      else
        do i = niu(kk1-1)+1, niu(kk1)
          if (iu2(i) .eq. kk2) then
            k = i
            if (iobs .eq. 0) k = k - (kk1-1)*Nprm
            return
            end if
          end do
        end if
c
      write(6, *) 'seaiu error'
      stop
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine seail(iobs, k1, k2, k)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    ni, niu(0:maxM), iu1(maxRM), iu2(maxRM),
     &               nil(0:maxM), il1(maxRM), il2(maxRM)
      common     /iccg3/ ni, niu, iu1, iu2, nil, il1, il2
c
      integer    iobs, k1, k2, k
      integer    i, j1, j2, j3, j4, kk1, kk2
c -------------------------------------------------------------------- c
      if (k1 .lt. k2) then
        kk1 = k2
        kk2 = k1
      else
        kk1 = k1
        kk2 = k2
        end if
c
      if (kk1 .gt. Np) then
        k = nil(kk1-1) + kk2
        return
      else
        do i = nil(kk1-1)+1, nil(kk1)
          if (il2(i) .eq. kk2) then
            k = i
            return
            end if
          end do
        end if
c
      write(6, *) 'seail error', k1, k2
      stop
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine addiu(np, j1, j2, l, nz, i1, i2)
      include    'baydelo.def'
c
      integer    np, j1, j2, l, nz(0:maxM), i1(maxRM), i2(maxRM)
      integer    i, j, k, k1, k2
c -------------------------------------------------------------------- c
      if (j1 .eq. j2) return
      if (j1 .gt. j2) then
        k1 = j2
        k2 = j1
      else
        k1 = j1
        k2 = j2
        end if
c
      k = nz(k1) + 1
      if (nz(k1-1) .ne. nz(k1)) then
        do i = nz(k1-1)+1, nz(k1)
          if (i2(i) .eq. k2) return
          if (k2 .lt. i2(i)) then
            k = i
            exit
            end if
          end do
        end if
c
      l = l + 1
      if (l .gt. maxRM) then
        write(6, *) 'l > maxRM 3'
        stop
        end if
c
      do j = l-1, k, -1
        i1(j+1) = i1(j)
        i2(j+1) = i2(j)
        end do
      i1(k) = k1
      i2(k) = k2
      do j = k1, np
        nz(j) = nz(j) + 1
        end do
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine sortul(np, nm, nz, i1, i2)
      include    'baydelo.def'
c
      integer    np, nm, nz(0:maxM), i1(maxRM), i2(maxRM)
c
      integer    i, j, k, l, ne, nw, i1w(maxM), i2w(maxM)
c -------------------------------------------------------------------- c
      write(6, *) ' sortul start', np, nm
      nz(0) = 0
      do i = 1, np
        nw = 0
        ne = nm
        do j = nm, nz(i-1)+1, -1
          if (iabs(i1(j)).eq.i) then
            nw = nw + 1
            if (nw .gt. maxM) then
              write(6, *) 'nw .gt. maxM'
              stop
              end if
            if (nw.eq.1 .or. i2(j).ge.i2w(nw-1)) then
              i1w(nw) = i1(j)
              i2w(nw) = i2(j)
            else
              do k = 1, nw-1
                if (i2(j).lt.i2w(k)) then
                  do l = nw, k+1, -1
                    i1w(l) = i1w(l-1)
                    i2w(l) = i2w(l-1)
                    end do
                  i1w(k) = i1(j)
                  i2w(k) = i2(j)
                  exit
                  end if
                end do
              end if
          else
            i1(ne) = i1(j)
            i2(ne) = i2(j)
            ne = ne - 1
            end if
          end do
        nz(i) = nz(i-1) + nw
        do k = 1, nw
          i1(k+nz(i-1)) = i1w(k)
          i2(k+nz(i-1)) = i2w(k)
          end do
        end do
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine DLOerr(rss)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    i, j
      real*8     rss, rs, sdx, w
c -------------------------------------------------------------------- c
      write(6, *) ' DLOerr start '
c
      rss = 0.0d0
c
      do i = 1, Np
        if (No(i) .gt. 0) then
c         rs  = (Gp(i) - Gmin) / (Gmax - Gmin) - S(i)
          w = Gp(i)
          if (Nprm .ne. 0) then
            do j = 1, Nprm
              w = w - Hp(i, j) * S(Np+j)
              end do
            end if
          rs  = w - S(i)
          rss = rss + rs**2
          end if
        end do
c
c     sdx = dsqrt(rss / dfloat(Nd)) * (Gmax - Gmin)
      sdx = dsqrt(rss / dfloat(Nd))
      write(6, '(a, f10.5)') ' Fitting standard deviation = ', sdx
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine DLOwtr(ifile, sd, rss, w1, w2, wABIC)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      integer    ifile, i
      real*8     sd, rss, w1, w2, wABIC, w
c -------------------------------------------------------------------- c
      write(6, *) ' DLOwtr start '
c
      write(ifile, '(a)') 'Point'
      write(ifile, '(i8)') Np
      Nd = 0
      w = Gmax - Gmin
      do i = 1, Np
        write(ifile, '(2i7, 2f12.3, 4f15.9)')
     &    i, No(i), Xp(i), Yp(i), S(i)
        if (No(i) .gt. 0) Nd = Nd + 1
        end do
c
      write(ifile, '(a)') 'Line'
      write(ifile, '(i8)') Nl
      do i = 1, nl
        write(ifile, '(5i8)') i, Ls(i), Le(i), Lt(i), Rt(i)
        end do
c
      write(ifile, '(a)') 'Triangle'
      write(ifile, '(i8)') Nt
      do i = 1, Nt
        write(ifile, '(4i8)') i, Tp(1, i), Tp(2, i), Tp(3, i)
        end do
c
      write(ifile, '(a)') 'Parameters'
      write(ifile, '(4D13.6)') sd, w1, w2, wABIC
      write(ifile, '(a20, 2D15.8)') '       rss,  sd =   ',
     &            rss, dsqrt(rss / dfloat(Nd))
      write(ifile, '(6D13.6)') (S(i), errS(i), i=Np+1, Np+Nprm)
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine calRSR(w1, w2, rsr)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      real*8     w1, w2, rsr
c
      integer    i
      real*8     xymax, c
c
      integer    j1, j2, j3, j4
      real*8     x1, y1, x2, y2, x3, y3, x4, y4
      real*8     x12, x23, x31, y21, y32, y13
c
      real*8     x12l, x23l, x31l, y21l, y32l, y13l
      real*8     x12r, x23r, x31r, y21r, y32r, y13r
c -------------------------------------------------------------------- c
      write(6, *) ' calRSR start '
c
      rsr = 0.0d0
      xymax = Xmax - Xmin
      if (Ymax-Ymin.gt.xymax) xymax = Ymax - Ymin
c
      do i = 1, Nt
        j1 = Tp(1, i)
        j2 = Tp(2, i)
        j3 = Tp(3, i)
        x1 = (Xp(j1) - Xmin) / xymax
        y1 = (Yp(j1) - Ymin) / xymax
        x2 = (Xp(j2) - Xmin) / xymax
        y2 = (Yp(j2) - Ymin) / xymax
        x3 = (Xp(j3) - Xmin) / xymax
        y3 = (Yp(j3) - Ymin) / xymax
        c = (x1 - x3) * (y1 - y2) - (x1 - x2) * (y1 - y3)
        c = dsqrt(w1 * At(i)) / c
        x12 = (x1 - x2) * c
        x23 = (x2 - x3) * c
        x31 = (x3 - x1) * c
        y21 = (y2 - y1) * c
        y32 = (y3 - y2) * c
        y13 = (y1 - y3) * c
        rsr = rsr + (y32*S(j1) + y13*S(j2) + y21*S(j3))**2 +
     &              (x23*S(j1) + x31*S(j2) + x12*S(j3))**2
        end do
c
      do i = 1, Nl
        if (Lt(i).eq.0 .or. Rt(i).eq.0) cycle
        j1 = Ls(i)
        j2 = Le(i)
        j3 = Rp(i)
        j4 = Lp(i)
        x1 = (Xp(j1) - Xmin) / xymax
        y1 = (Yp(j1) - Ymin) / xymax
        x2 = (Xp(j2) - Xmin) / xymax
        y2 = (Yp(j2) - Ymin) / xymax
        x3 = (Xp(j3) - Xmin) / xymax
        y3 = (Yp(j3) - Ymin) / xymax
        x4 = (Xp(j4) - Xmin) / xymax
        y4 = (Yp(j4) - Ymin) / xymax
        c = (x1 - x4) * (y1 - y2) - (x1 - x2) * (y1 - y4)
        c = dsqrt(w2 * Wl(i)) / c
        x12r = (x1 - x2) * c
        x23r = (x2 - x4) * c
        x31r = (x4 - x1) * c
        y21r = (y2 - y1) * c
        y32r = (y4 - y2) * c
        y13r = (y1 - y4) * c
        c = (x2 - x3) * (y2 - y1) - (x2 - x1) * (y2 - y3)
        c = dsqrt(w2 * Wl(i)) / c
        x12l = (x2 - x1) * c
        x23l = (x1 - x3) * c
        x31l = (x3 - x2) * c
        y21l = (y1 - y2) * c
        y32l = (y3 - y1) * c
        y13l = (y2 - y3) * c
        rsr = rsr +
     &        ((y13l-y32r)*S(j1) + (y32l-y13r)*S(j2)
     &          + y21l*S(j3) - y21r*S(j4))**2 +
     &        ((x31l-x23r)*S(j1) + (x23l-x31r)*S(j2)
     &          + x12l*S(j3) - x12r*S(j4))**2
        end do
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine simplx(xinit, n, funct, dist, eps, fr)
c -------------------------------------------------------------------- c
c -- parameter: ------------------------------------------------------ c
c ---- I/O xinit:      vector of initial and final x ----------------- c
c ---- I   n:          dimension of the vector x --------------------- c
c ---- I   funct:      minimize function ----------------------------- c
c ---- I   dist:       size of first simplex ------------------------- c
c ---- I   eps:        epsilon --------------------------------------- c
c ---- O   fr:         final value ----------------------------------- c
c -------------------------------------------------------------------- c
c -- This subroutine call next subroutine and function. -------------  c
c --------- first, minmax, newsim, center, reduce, update, epslon ---- c
c -------------------------------------------------------------------- c
      include    'baydelo.def'
c
      external   funct
c
      integer    n
      real*8     xinit(maxH), dist, eps, fr
c
      integer    iter, xh, xs, xl, x0, xr, xe, xc, j
      real*8     f(maxH5), x(maxH5, maxH)
      real*8     epslon
      real*8     eps1, ALPHA, BETA, GAMMA
c
      data       ALPHA/-1.0d0/, BETA/0.5d0/, GAMMA/2.0d0/
c -------------------------------------------------------------------- c
      x0 = n + 2
      xr = n + 3
      xe = n + 4
      xc = n + 5
c
      call first(n, f, x, funct, xinit, dist)
      if (dist .eq. 0.0d0) return
c -------------------------------------------------------------------- c
c     open(2, file='simplex.line')
      iter = 0
c
c                                                ****   main loop   ****
1     continue
c
c     write(2, '(1hm, 2f10.3)') x(1,1), x(1,2)
c     write(2, '(1hl, 2f10.3)') x(2,1), x(2,2)
c     write(2, '(1hl, 2f10.3)') x(3,1), x(3,2)
c     write(2, '(1hl, 2f10.3)') x(1,1), x(1,2)
c
c                                           ****   min max search   ****
      call minmax(n, f, xh, xs, xl)
c
c                                            ****   epsilon check   ****
      eps1 = epslon(n, f)
      write(6, '(31h ####  iteration, f, epsilon = , i5, 2D16.8)')
     &          iter, f(xl), eps1
c
      if (iter .gt. 2 .and. eps1 .lt. eps) go to 2
c
c                                               ****   center set   ****
      call center(n, x, xh, x0)
c
c                                               ****   reflection   ****
      call newsim(n, f, x, funct, x0, xh, ALPHA, xr)
c
      if (f(xr) .le. f(xs)) then
c
        if (f(xr) .lt. f(xl)) then
c
c                                                ****   expansion   ****
          call newsim(n, f, x, funct, x0, xr, GAMMA, xe)
c
          if (f(xe) .lt. f(xr)) then
            call update(n, f, x, xe, xh)
          else
            call update(n, f, x, xr, xh)
            end if
c
        else
          call update(n, f, x, xr, xh)
          end if
c
      else
c
        if (f(xr) .lt. f(xh)) call update(n, f, x, xr, xh)
c
c                                              ****   contraction   ****
        call newsim(n, f, x, funct, x0, xh, BETA, xc)
c
        if (f(xc) .lt. f(xh)) then
          call update(n, f, x, xc, xh)
c
        else
c                                                   ****   reduce   ****
          call reduce(n, f, x, funct, xl)
c
          end if
c
        end if
c
      iter = iter + 1
c
      if (iter .gt. 50) go to 2
c
      go to 1
c
2     continue
c     close(2)
c
      do 10 j = 1, n
        xinit(j) = x(xl, j)
10      continue
      fr = f(xl)
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine minmax(n, f, xh, xs, xl)
c
      include    'baydelo.def'
c
      integer    n, xh, xs, xl
      real*8     f(maxH5)
c
      integer    i
      real*8     fmin1, fmax1, fmax2
c -------------------------------------------------------------------- c
      if (f(1) .gt. f(2)) then
        fmax1 = f(1)
        xh = 1
        fmax2 = f(2)
        xs = 2
        fmin1 = f(2)
        xl = 2
      else
        fmax1 = f(2)
        xh = 2
        fmax2 = f(1)
        xs = 1
        fmin1 = f(1)
        xl = 1
        end if
c
      do 10 i = 3, n+1
c
        if (f(i) .gt. fmax1) then
          fmax2 = fmax1
          xs = xh
          fmax1 = f(i)
          xh = i
c
        else if (f(i) .gt. fmax2) then
          fmax2 = f(i)
          xs = i
          end if
c
        if (f(i) .lt. fmin1) then
          fmin1 = f(i)
          xl = i
          end if
c
10      continue
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine first(n, f, x, funct, xinit, dist)
c
      include    'baydelo.def'
c
      external   funct
c
      integer    n
      real*8     f(maxH5), x(maxH5, maxH), xinit(maxH), xx(maxH), dist
c
      integer    i, j
c -------------------------------------------------------------------- c
      do 10 i = 1, n + 1
c
        do 20 j = 1, n
          x(i, j) = xinit(j)
          xx(j) = x(i, j)
20        continue
c
        if (i .ne. 1) then
          if (dist .eq. 0.0d0) return
          x(i, i-1) = x(i, i-1) + dist
          xx(i-1) = x(i,i-1)
          end if
c
        call funct(n, xx, f(i))
c
10      continue
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine center(n, x, xh, x0)
c
      include    'baydelo.def'
c
      integer    n, xh, x0
      real*8     x(maxH5, maxH)
c
      integer    i, j
c -------------------------------------------------------------------- c
      do 10 j = 1, n
        x(x0, j) = 0.0d0
        do 20 i = 1, n+1
          if (i .ne. xh) x(x0, j) = x(x0, j) + x(i, j)
20        continue
        x(x0, j) = x(x0, j) / dfloat(n)
10      continue
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      function   epslon(n, f)
c
      include    'baydelo.def'
c
      integer    n
      real*8     f(maxH5)
c
      integer    i
      real*8     epslon, emean
c -------------------------------------------------------------------- c
      emean = 0.0d0
      do 10 i = 1, n+1
        emean = emean + f(i)
10      continue
      emean = emean / dfloat(n+1)
c
      epslon = 0.0d0
      do 20 i = 1, n+1
        epslon = epslon + (f(i) - emean) ** 2
20      continue
      epslon = dsqrt(epslon) / dfloat(n+1)
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine newsim(n, f, x, funct, x0, in, prm, out)
c
      include    'baydelo.def'
c
      external   funct
c
      integer    n, x0, in, out
      real*8     f(maxH5), x(maxH5,maxH), xx(maxH), prm
c
      integer    j
c -------------------------------------------------------------------- c
      do 10 j = 1, n
        x(out, j) = prm * x(in, j) + (1.0d0 - prm) * x(x0, j)
        xx(j) = x(out,j)
10      continue
      call funct(n, xx, f(out))
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine update(n, f, x, in, out)
c
      include    'baydelo.def'
c
      integer    n, in, out
      real*8     f(maxH5), x(maxH5, maxH)
c
      integer    j
c -------------------------------------------------------------------- c
      do 10 j = 1 , n
        x(out, j) = x(in, j)
10      continue
c
      f(out) = f(in)
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine reduce(n, f, x, funct, xl)
c
      include    'baydelo.def'
c
      external   funct
c
      integer    n, xl
      real*8     f(maxH5), x(maxH5, maxH), xx(maxH)
c
      integer    i, j
c -------------------------------------------------------------------- c
      do 10 i = 1, n+1
c
        if (i .ne. xl) then
c
          do 20 j = 1, n
            x(i, j) = (x(i, j) + x(xl, j)) / 2.0d0
            xx(j) = x(i, j)
20          continue
          call funct(n, xx, f(i))
c
          end if
c
10      continue
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine datred(w1, w2, dist, eps)
c
      include    'baydelo.def'
      include    'baydelo.com'
c
      character  tx*10
      integer    i, j
      real*8     w1, w2, dist, eps, xymax, x1, y1, x2, y2, d, w
c -------------------------------------------------------------------- c
      write(6, *) ' datred start'
      read(5, '(a50)') DLOin
      read(5, '(a50)') DLOout
      read(5, *) w1, w2, dist, eps, Nprm
      if (Nprm .gt. mPRM) then
        write(6, *) 'Nprm .gt. mPRM'
        stop
        end if
c
      open(2, file=DLOin)
c
      read(2, '(a10)') tx
      read(2, *) Np
      if (Np .gt. mP) then
        write(6, *) 'Np .gt. mP'
        stop
        end if
      Nd = 0
      Xmin =  9.9d29
      Xmax = -9.9d29
      Ymin =  9.9d29
      Ymax = -9.9d29
      Gmin =  9.9d29
      Gmax = -9.9d29
      do i = 1, Np
        read(2, *) j, No(i), Xp(i), Yp(i), Gp(i), (Hp(i, j), j=1, Nprm)
        if (Xp(i) .lt. Xmin) Xmin = Xp(i)
        if (Xp(i) .gt. Xmax) Xmax = Xp(i)
        if (Yp(i) .lt. Ymin) Ymin = Yp(i)
        if (Yp(i) .gt. Ymax) Ymax = Yp(i)
        if (No(i) .gt. 0) then
          if (Gp(i) .lt. Gmin) Gmin = Gp(i)
          if (Gp(i) .gt. Gmax) Gmax = Gp(i)
          Nd = Nd + 1
          end if
        end do
      read(2, '(a10)') tx
      read(2, *) Nl
      if (Nl .gt. mL) then
        write(6, *) 'Nl .gt. mL'
        stop
        end if
      do i = 1, nl
        read(2, *) j, Ls(i), Le(i), Lt(i), Rt(i)
        end do
      read(2, '(a10)') tx
      read(2, *) Nt
      if (Nt .gt. mT) then
        write(6, *) 'Nt .gt. mT'
        stop
        end if
      do i = 1, Nt
        read(2, *) j, Tp(1, i), Tp(2, i), Tp(3, i)
        end do
      close(2)
c
      xymax = Xmax - Xmin
      if (Ymax - Ymin .gt. xymax) xymax = Ymax - Ymin
      w = 0.0
      do i = 1, Nt
        At(i) = (Yp(Tp(1, i))*(Xp(Tp(2, i))-Xp(Tp(3, i)))
     &        +  Yp(Tp(2, i))*(Xp(Tp(3, i))-Xp(Tp(1, i)))
     &        +  Yp(Tp(3, i))*(Xp(Tp(1, i))-Xp(Tp(2, i))))
     &        / 2.0d0 / xymax**2
        if (At(i) .lt. 0.0d0) write(6, *) At(i)
        if (At(i) .lt. 0.0d0) At(i) = -At(i)
        if (w .lt. At(i)) w = At(i)
        end do
      do i = 1, Nt
        At(i) = At(i) / w / 1000.0d0
        end do
      w = 0.0
c
c     do i = 1, Nl
c       if (Lt(i).ne.0 .and. Rt(i).ne.0) then
c         x1 = (Xp(Tp(1,Lt(i)))+Xp(Tp(2,Lt(i)))+Xp(Tp(3,Lt(i))))/3.0d0
c         y1 = (Yp(Tp(1,Lt(i)))+Yp(Tp(2,Lt(i)))+Yp(Tp(3,Lt(i))))/3.0d0
c         x2 = (Xp(Tp(1,Rt(i)))+Xp(Tp(2,Rt(i)))+Xp(Tp(3,Rt(i))))/3.0d0
c         y2 = (Yp(Tp(1,Rt(i)))+Yp(Tp(2,Rt(i)))+Yp(Tp(3,Rt(i))))/3.0d0
c         d = dsqrt((x1-x2)**2 + (y1-y2)**2) / xymax
c         Wl(i) = (At(Lt(i)) + At(Rt(i))) / 3.0d0 * d
c         if (w .lt. Wl(i)) w = Wl(i)
c         end if
c       end do
c
      do i = 1, Nl
        if (Lt(i).ne.0 .and. Rt(i).ne.0) then
          Wl(i) = (At(Lt(i)) + At(Rt(i))) / 3.0d0
          if (w .lt. Wl(i)) w = Wl(i)
          end if
c
        end do
      do i = 1, Nl
        Wl(i) = Wl(i) / w
        end do
c
      do i = 1, nl
        j = Lt(i)
        if (j .eq. 0) then
          Lp(i) = 0
        else
          if (Tp(1, j).ne.Ls(i) .and. Tp(1, j).ne.Le(i)) then
            Lp(i) = Tp(1, j)
          else if (Tp(2, j).ne.Ls(i) .and. Tp(2, j).ne.Le(i)) then
            Lp(i) = Tp(2, j)
          else if (Tp(3, j).ne.Ls(i) .and. Tp(3, j).ne.Le(i)) then
            Lp(i) = Tp(3, j)
          else
            write(6, *) 'Relation Lt, Rt & Tp Error'
            stop
            end if
          end if
        j = Rt(i)
        if (j .eq. 0) then
          Rp(i) = 0
        else
          if (Tp(1, j).ne.Ls(i) .and. Tp(1, j).ne.Le(i)) then
            Rp(i) = Tp(1, j)
          else if (Tp(2, j).ne.Ls(i) .and. Tp(2, j).ne.Le(i)) then
            Rp(i) = Tp(2, j)
          else if (Tp(3, j).ne.Ls(i) .and. Tp(3, j).ne.Le(i)) then
            Rp(i) = Tp(3, j)
          else
            write(6, *) 'Relation Lt, Rt & Tp Error'
            stop
            end if
          end if
        end do
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine crconv(iobs, n, m, a1, a2)
c
      include    'baydelo.def'
      integer    nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      common     /iccg1/ nzu, nzl, iu, il
c
      integer  iobs, n, m
      real*8   a1(maxRM), a2(maxRM)
c
      integer  i, j, k
c -------------------------------------------------------------------- c
      write(6, *) ' crconv start ', n, m
c
      if (m .eq. 0) then 
        do i = 1, n
          do j = nzu(i-1)+1, nzu(i)
            call seail(iobs, iu(j), i, k)
            a2(k) = a1(j)
            end do
          end do
      else
        do i = 1, n
          do j = nzl(i-1)+1, nzl(i)
            call seaiu(iobs, il(j), i, k)
            a2(k) = a1(j)
            end do
          end do
        end if
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine icdcmp(n, nzl, il, al, ad, ul, ud)
c*****************************************************
c                                                    *
c       incomplete cholesky decomposition of a       *
c             into ldlt in iccg method               *
c              (lt = transpose of l)                 *
c                                                    *
c     relation between l(k,k) and d(k) is            *
c           l(k,k) * d(k) = 1   (iccg version)       *
c                                                    *
c*****************************************************
      include    'baydelo.def'
c
      integer  n, nzl(0:maxM), il(maxRM)
      real*8   al(maxRM), ad(maxM), ul(maxRM), ud(maxM)
c
      integer  k, i, mui, muk, mu
      real*8   eps, t
      character line*150
c -------------------------------------------------------------------- c
      write(6, *) ' icdcmp start '
c
c     do k = 1, n
c       line = ''
c       do i = nzl(k-1)+1, nzl(k)
c         mu = il(i) * 12 - 11
c         write(line(mu:mu+11), '(f12.7)') al(i)
c         end do
c       mu = k * 12 - 11
c       write(line(mu:mu+11), '(f12.7)') ad(k)
c       write(6, '(a150)') line
c       end do
c
      eps = 1.0d-6
      do 10 k = 1, n
        if (nzl(k) .eq. nzl(k-1)) go to 2
        do 20 mu = nzl(k-1)+1, nzl(k)
          i = il(mu)
          mui = nzl(i-1) + 1
          muk = nzl(k-1) + 1
          ul(mu) = al(mu)
c         if (nzl(i) .eq. nzl(i-1)) write(6, '(3d17.7)') ul(mu)
          if (nzl(i) .eq. nzl(i-1)) cycle
    1     continue
          if (il(mui) .gt. il(muk)) then
            muk = muk + 1
          else if (il(mui) .lt. il(muk)) then
            mui = mui + 1
          else
            ul(mu) = ul(mu) - ud(il(muk)) * ul(mui) * ul(muk)
            mui = mui + 1
            muk = muk + 1
            end if
c         write(6, '(3d17.7)') ul(mu)
          if (mui.le.nzl(i) .and. muk.le.nzl(k)) go to 1
   20   continue
c
2       t = ad(k)
        do 530 mu = nzl(k-1)+1, nzl(k)
          t = t - ud(il(mu)) * ul(mu)**2
  530   continue
        if (abs(t) .le. eps) t = eps
        ud(k) = 1.0d0 / t
   10 continue
c
c     do k = 1, n
c       line = ''
c       do i = nzl(k-1)+1, nzl(k)
c         mu = il(i) * 12 - 11
c         write(line(mu:mu+11), '(f12.7)') ul(i)
c         end do
c       mu = k * 12 - 11
c       write(line(mu:mu+11), '(f12.7)') ud(k)
c       write(6, '(a150)') line
c       end do
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine cg(n, nzu, nzl, iu, il,
     $              au, al, ad, b, eps, x,
     $              uu, ul, ud, r, p, ru, ap)
***************************************************
*                                                 *
*       conjugate gradient method for iccg        *
*                                                 *
***************************************************
      include    'baydelo.def'
c
      integer  n, nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      real*8   au(maxRM), al(maxRM), ad(maxM), b(maxM), eps, x(maxM)
      real*8   uu(maxRM), ul(maxRM), ud(maxM)
      real*8   r(maxM), p(maxM), ru(maxM), ap(maxM)
c
      integer  i, k, kend
      real*8   rur0, rur1, pap, res2, b2, eps2, alpha, beta
c -------------------------------------------------------------------- c
      write(6, *) ' cg start '
      kend = n * 10000
      eps2 = eps**2
*
*     ---- initialization ----
*
      call prodmv(n, nzu, nzl, iu, il, au, al, ad, x, ap)
*
      do 510 i = 1, n
        r(i) = b(i) - ap(i)
  510 continue
*
      call icsolv(n, nzu, nzl, iu, il, uu, ul, ud, r, ru)
*
      rur0 = 0.0d0
      do 520 i = 1, n
        p(i) = ru(i)
        rur0 = rur0 + r(i) * ru(i)
  520 continue
*
      b2 = 0.0d0
      do 530 i = 1, n
        b2 = b2 + b(i)**2
  530 continue
*
*     ---- iterative loop ----
*
      do 10 k = 1, kend
*
        call prodmv(n, nzu, nzl, iu, il, au, al, ad, p, ap)
*
        pap = 0.0d0
        do 540 i = 1, n
          pap = pap + p(i) * ap(i)
  540   continue
*
        alpha = rur0 / pap
        res2 = 0.0d0

        do 550 i = 1, n
          x(i) = x(i) + alpha * p(i)
          r(i) = r(i) - alpha * ap(i)
          res2 = res2 + r(i) ** 2
  550   continue
        if (mod(k, 10) .eq. 0)
     &    write(6,'(i7,5d14.6)') k, x(1), x(n/2),x(n), res2/b2, eps2
        if (                res2/b2 .le. 1.0d-40) return
        if (k.gt.n/4  .and. res2/b2 .le. 1.0d-10) return
        if (k.gt.n    .and. res2/b2 .le. 1.0d-02) return
        if (k.gt.n*2  .and. res2/b2 .le. 1.0d-00) return
*
        call icsolv(n, nzu, nzl, iu, il, uu, ul, ud, r, ru)
*
        rur1 = 0.0d0
*
        do 560 i = 1, n
          rur1 = rur1 + r(i) * ru(i)
  560   continue
*
        beta = rur1 / rur0
        rur0 = rur1
*
        do 570 i = 1, n
          p(i) = ru(i) + beta * p(i)
  570   continue
*
   10 continue
*
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine prodmv(n, nzu, nzl, iu, il, au, al, ad, x, ap)
c**************************************************
c                                                 *
c               compute product                   *
c          ap = (matrix a) * (vector x)           *
c                                                 *
c**************************************************
      include    'baydelo.def'
c
      integer  n, nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      real*8   au(maxRM), al(maxRM), ad(maxM)
      real*8   x(maxM), ap(maxM)
c
      integer  i, mu, nu
      real*8   apv
c -------------------------------------------------------------------- c
      do 10 i = 1, n
        apv = 0.0d0
        do 520 mu = nzl(i-1)+1, nzl(i)
          apv = apv + al(mu) * x(il(mu))
  520   continue
        do 530 nu = nzu(i-1)+1, nzu(i)
          apv = apv + au(nu) * x(iu(nu))
  530   continue
        apv = apv + ad(i) * x(i)
        ap(i) = apv
   10 continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine icsolv(n, nzu, nzl, iu, il, uu, ul, ud, b, x)
***************************************************
*                                                 *
*     solve system of linear equations            *
*              (l * d * lt) * x = b               *
*     in iccg method (lt = transpose of l)        *
*     ldlt is incomplete cholesky decomposition   *
*             arranged by icdcmp                  *
*                                                 *
***************************************************
      include    'baydelo.def'
c
      integer  n, nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      real*8   uu(maxRM), ul(maxRM), ud(maxM), b(maxM), x(maxM)
c
      integer  k, mu, nu
      real*8   t
c -------------------------------------------------------------------- c
c
c     ---- forward substitution ----
c
      do 10 k = 1, n
        t = b(k)
        do 520 mu = nzl(k-1)+1, nzl(k)
          t = t - ul(mu) * x(il(mu))
  520   continue
        x(k) = ud(k) * t
   10 continue
c
c     ---- backward substitution ----
c
      do 30 k = n, 1, -1
        t = 0.0d0
        do 540 nu = nzu(k-1)+1, nzu(k)
          t = t + uu(nu) * x(iu(nu))
  540   continue
        x(k) = x(k) - ud(k) * t
   30 continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine nmsets(n, nzu, nzl, iu, il)
c
      include    'baydelo.def'
      include    'icsolv.def'
c
      integer    n, nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      integer    n1, n2(0:nS), n3(0:nS), n4(0:mS), n5(4,lS)
      integer    m1, m2(0:nS), m3(0:nS), m4(0:mS), m5(4,lS)
c
      common     /ndim/ n1, n2, n3, n4, n5
      common     /mdim/ m1, m2, m3, m4, m5
c -------------------------------------------------------------------- c
      call nmset(n, nzu, nzl, iu, il, n1, n2, n3, n4, n5)
      write(6, *) 'n = ', n1, n2(n1), n3(n1), n4(n3(n1))
      call nmset(n, nzl, nzu, il, iu, m1, m2, m3, m4, m5)
      write(6, *) 'm = ', m1, m2(m1), m3(m1), m4(m3(m1))
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine nmset(n, nzu, nzl, iu, il, n1, n2, n3, n4, n5)
c
      include    'baydelo.def'
      include    'icsolv.def'
c
      integer    n, nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      integer    n1, n2(0:nS), n3(0:nS), n4(0:mS), n5(4,lS)
      integer    nzw(0:maxM)
c
      integer    i, j, k, k1, nw1, nw2, nw3, nw4, nw5
c -------------------------------------------------------------------- c
      do 10 k = 1, n
        nzw(k) = nzl(k) - nzl(k-1)
10      continue
c
      n1 = 0
      n2(0) = 0
      n3(0) = 0
      n4(0) = 0
      nw1 = 0
1     continue
      n1 = n1 + 1
      if (n1 .gt. nS) then
        write(6, *) 'n1 > nS'
        stop
        end if
c
      n2(n1) = n2(n1-1)
      do 11 k = 1, n
        if (nzw(k) .eq. 0) then
          n2(n1) = n2(n1) + 1
          if (n2(n1) .gt. lS) then
            write(6, *) 'n2(n1) > lS'
            stop
            end if
          n5(1, n2(n1)) = k
          nzw(k) = -1
          end if
11      continue
c
      nw2 = nw1
      do 12 k = 1, n
        if (nzw(k) .eq. -1) then
          do 13 j = nzu(k-1)+1, nzu(k)
            k1 = iu(j)
            nzw(k1) = nzw(k1) - 1
            nw3 = k1
            nw4 = k
            do 14 i = nzl(k1-1)+1, nzl(k1)
              if (il(i) .eq. k) then
                nw5 = i
                nw2 = nw2 + 1
                if (nw2 .gt. lS) then
                  write(6, *) 'nw2 > lS'
                  stop
                  end if
                n5(2, nw2) = nw3
                n5(3, nw2) = nw4
                n5(4, nw2) = nw5
                go to 13
                end if
14            continue
13          continue
          nzw(k) = -2
          end if
12      continue
c
      if (nw1 .ne. nw2) then
        call nmsort(n1, n3, n4, nw1, nw2, n5)
        write(6, '(10i6)') n1, n2(n1)-n2(n1-1), n3(n1)-n3(n1-1),
     &      (n4(i)-n4(i-1),i=n3(n1-1)+1, n3(n1))
        nw1 = nw2
        go to 1
        end if
      write(6, '(10i6)') n1, n2(n1)-n2(n1-1), n3(n1)-n3(n1-1),
     &    (n4(i)-n4(i-1),i=n3(n1-1)+1, n3(n1))
      write(6, '(i9, a, i8)') n1, ' used in nS:', nS
      write(6, '(i9, a, i8)') n3(n1), ' used in mS:', mS
      write(6, '(i9, a, i8)') nw2, ' used in lS:', lS
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine nmsort(n1, n3, n4, nw1, nw2, n5)
c
      include    'icsolv.def'
c
      integer    n1, n3(0:nS), n4(0:mS), nw1, nw2, n5(4,lS)
      integer    is(lS)
c -------------------------------------------------------------------- c
      do 10 i = 1, lS
        is(i) = 1
10      continue
c
      m1 = nw2 - nw1
      do 20 i = nw2, nw1+2, -1
        m2 = n5(2, i)
        do 30 j = nw1+1, i-1
          if (m2 .eq. n5(2, j)) is(m1) = is(m1) + 1
30        continue
        m1 = m1 - 1
20      continue
c
      do 40 i = 2, nw2-nw1
        do 50 j = 1, i-1
          if (is(i) .lt. is(j)) then
            l = i + nw1
            isw1 = is(i)
            isw2 = n5(2, l)
            isw3 = n5(3, l)
            isw4 = n5(4, l)
            do 60 k = i-1, j, -1
              l = k + nw1
              is(k+1) = is(k)
              n5(2, l+1) = n5(2, l)
              n5(3, l+1) = n5(3, l)
              n5(4, l+1) = n5(4, l)
60            continue
            l = j + nw1
            is(j) = isw1
            n5(2, l) = isw2
            n5(3, l) = isw3
            n5(4, l) = isw4
            go to 40
            end if
50        continue
40      continue
c
      j = 0
      k = 2
      n3(n1) = n3(n1-1) + 1
      do 70 i = nw1+1, nw2
        j = j + 1
        if (is(j) .eq. k) then
          n3(n1) = n3(n1) + 1
          if (n3(n1) .gt. mS) then
            write(6, *) 'n3(n1) > mS'
            stop
            end if
          k = k + 1
          end if
        n4(n3(n1)) = i
70      continue
      n3(n1+1) = n3(n1)
      n4(n3(n1)+1) = n4(n3(n1))
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine icsolv2(n, nzu, nzl, iu, il, uu, ul, ud, b, x)
c
      include    'baydelo.def'
      include    'icsolv.def'
c
      integer    n, nzu(0:maxM), nzl(0:maxM), iu(maxRM), il(maxRM)
      integer    n1, n2(0:nS), n3(0:nS), n4(0:mS), n5(4,lS)
      integer    m1, m2(0:nS), m3(0:nS), m4(0:mS), m5(4,lS)
c
      real*8     uu(maxRM), ul(maxRM), ud(maxM), b(maxM), x(maxM)
      real*8     td(maxRM)
c
      common     /ndim/ n1, n2, n3, n4, n5
      common     /mdim/ m1, m2, m3, m4, m5
c
      integer    i, j, k, l, k1, k2, k3
c -------------------------------------------------------------------- c
      do 10 i = 1, n
        td(i) = 0.0D0
10      continue
c
      do 11 i = 1, n1
        do 12 j = n2(i-1)+1, n2(i)
          k = n5(1, j)
          x(k) = ud(k) * (b(k) + td(k))
12        continue
        do 13 j = n3(i-1)+1, n3(i)
*poption parallel
          do 13 l = n4(j-1)+1, n4(j)
            td(n5(2, l)) = td(n5(2, l)) - ul(n5(4, l)) * x(n5(3, l))
13        continue
11      continue
c -------------------------------------------------------------------- c
      do 20 i = 1, n
        td(i) = 0.0D0
20      continue
c
      do 21 i = 1, m1
        do 22 j = m2(i-1)+1, m2(i)
          k = m5(1, j)
          x(k) = x(k) - ud(k) * td(k)
22        continue
        do 23 j = m3(i-1)+1, m3(i)
*poption parallel
          do 23 l = m4(j-1)+1, m4(j)
            td(m5(2, l)) = td(m5(2, l)) + uu(m5(4, l)) * x(m5(3, l))
23        continue
21      continue
c -------------------------------------------------------------------- c
      return
      end
