      implicit   none
c
      integer    mp, mr
      parameter  (mp = 7000, mr = 7000)
      integer    np, ip(mp), nin, nr
      real*8     xmin, ymin, xmax, ymax, xp(mp), yp(mp), gp(mp, mr)
      common     /ipoint/ np, ip, nin, nr
      common     /rpoint/ xmin, ymin, xmax, ymax, xp, yp, gp
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      real*8     dlensq, accy
      common     /iline/ nl, ls, le, lp, rp
      common     /rline/ dlensq, accy
c
      integer    mt
      parameter  (mt = 1000000)
      integer    nt, p3(3, mt)
      common     /itria/ nt, p3
c
      integer    i, j
      character  argv*20
c -------------------------------------------------------------------- c
      nin = 0
      call getarg(1, argv)
      if (argv .ne. '') read(argv, *) nin
      nr = 1
      call getarg(2, argv)
      if (argv .ne. '') read(argv, *) nr
      dlensq = 30000.0
      call getarg(3, argv)
      if (argv .ne. '') read(argv, *) dlensq
      write(0, *) dlensq
      dlensq = dlensq * dlensq
      call init
c
      write(0, *) '# pntred start'
      call pntred
c
      write(0, *) '# linsea start'
      call linsea
c
      write(0, *) '# trimk start'
      accy = dmin1(xmax-xmin, ymax-ymin) * 1.0d-10
      call trimk
c
      write(6, '(a)') 'Point'
      write(6, '(i8)') np
      do i = 1, np
        write(6, '(2i7, 2f12.3, 2f9.3, 99(99f16.12))')
     &    i, ip(i), xp(i), yp(i), (gp(i, j), j=1, nr)
        end do
c
      write(6, '(a)') 'Line'
      write(6, '(i8)') nl
      do i = 1, nl
        write(6, '(5i8)') i, ls(i), le(i), lp(i), rp(i)
        end do
c
      write(6, '(a)') 'Triangle'
      write(6, '(i8)') nt
      do i = 1, nt
        write(6, '(4i8)') i, p3(1, i), p3(2, i), p3(3, i)
        end do
c -------------------------------------------------------------------- c
      stop
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine init
      implicit   none
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      real*8     dlensq, accy
      common     /iline/ nl, ls, le, lp, rp
      common     /rline/ dlensq, accy
c
      integer    mt
      parameter  (mt = 1000000)
      integer    nt, p3(3, mt)
      common     /itria/ nt, p3
c
      integer    i
c -------------------------------------------------------------------- c
      call srand(2001)
c
      nl = 0
      do i = 1, ml
        ls(i) = 0
        le(i) = 0
        lp(i) = 0
        rp(i) = 0
        end do
c
      nt = 0
      do i = 1, mt
        p3(1, i) = 0
        p3(2, i) = 0
        p3(3, i) = 0
        end do
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine trimk
      implicit   none
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      real*8     dlensq, accy
      common     /iline/ nl, ls, le, lp, rp
      common     /rline/ dlensq, accy
c
      integer    i, j, k
c -------------------------------------------------------------------- c
      j = nl
      i = 0
1     i = i + 1
      if (mod(i, 100).eq.0) write(0, *) '# i, nl = ', i, nl
      if (i .gt. nl) go to 2
      if (lp(i).eq.0 .or. rp(i).eq.0) call trisea(i)
      go to 1
c -------------------------------------------------------------------- c
2     return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine trisea(ll)
      implicit   none
      integer    ll
c
      integer    mp, mr
      parameter  (mp = 7000, mr = 7000)
      integer    np, ip(mp), nin, nr
      real*8     xmin, ymin, xmax, ymax, xp(mp), yp(mp), gp(mp, mr)
      common     /ipoint/ np, ip, nin, nr
      common     /rpoint/ xmin, ymin, xmax, ymax, xp, yp, gp
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      real*8     dlensq, accy
      common     /iline/ nl, ls, le, lp, rp
      common     /rline/ dlensq, accy
c
      integer    mt
      parameter  (mt = 1000000)
      integer    nt, p3(3, mt)
      common     /itria/ nt, p3
c
      integer    i, j, k, ic, l1, l2, lsl, lel
      real*8     xk, yk, xl, yl, xm, ym, rccsqw, rccsq, xcc, ycc,
     &           xlk, ylk, xmk, ymk, xml, yml, detinv, det,
     &           rlksq, rmksq, rsq, rinv, a, b, c, sr
c -------------------------------------------------------------------- c
      lsl = ls(ll)
      lel = le(ll)
      xk = xp(lsl)
      yk = yp(lsl)
      xl = xp(lel)
      yl = yp(lel)
      xlk = xl - xk
      ylk = yl - yk
      rsq = xlk*xlk + ylk*ylk
      rinv = 1.0d0 / dsqrt(rsq)
      a = -ylk*rinv
      b = xlk*rinv
      c = (xk*yl - xl*yk)*rinv
      rccsqw = 9.0d+20
      do j = 1, np
        if (j.ne.lsl .and. j.ne.lel) then
          xm = xp(j)
          ym = yp(j)
c ---------------------------------- sr +: left side -: right side --- c
          sr = a * xm + b * ym + c
          if (sr .eq. 0.0d0) go to 1
          if (sr.gt.0.0d0 .and. lp(ll).ne.0) go to 1
          if (sr.lt.0.0d0 .and. rp(ll).ne.0) go to 1
          xmk = xm - xk
          ymk = ym - yk
          if (xmk*xmk+ymk*ymk .gt. dlensq) go to 1
          xml = xm - xl
          yml = ym - yl
          if (xml*xml+yml*yml .gt. dlensq) go to 1
          det = xlk * ymk - xmk * ylk
          if (dabs(det) .gt. accy) then
            detinv = 0.5d0 / det
            rlksq = xlk * xlk + ylk * ylk
            rmksq = xmk * xmk + ymk * ymk
            xcc = detinv * (rlksq*ymk - rmksq*ylk)
            ycc = detinv * (xlk*rmksq - xmk*rlksq)
            rccsq = xcc*xcc + ycc*ycc
            xcc = xcc + xk
            ycc = ycc + yk
            do k = 1, np
              if (k.ne.lsl .and. k.ne.lel .and. k.ne.j) then
                rccsqw = (xp(k)-xcc)*(xp(k)-xcc)+(yp(k)-ycc)*(yp(k)-ycc)
                if (rccsqw+accy .lt. rccsq) go to 1
                end if
              end do
            call lintri(ll, lsl, lel, j, sr)
            if (mod(nt, 100).eq.0) write(0, *) '# nt = ', nt
            if (lp(ll).ne.0 .and. rp(ll).ne.0) return
            end if
          end if
1       continue
        end do
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine lintri(ll, lsl, lel, j, sr)
      implicit   none
      integer    ll, lsl, lel, j
      real*8     sr
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      real*8     dlensq, accy
      common     /iline/ nl, ls, le, lp, rp
      common     /rline/ dlensq, accy
c
      integer    mt
      parameter  (mt = 1000000)
      integer    nt, p3(3, mt)
      common     /itria/ nt, p3
c
      integer    linchk, l1, l2
c -------------------------------------------------------------------- c
      if (sr .le. 0.0d0) then
        if (linchk(lel, j, l1).ne.0 .or.
     &      linchk(j, lsl, l2).ne.0) return
        nt = nt + 1
        call linadd(lel, j, l1, nt)
        call linadd(j, lsl, l2, nt)
        rp(ll) = nt
        p3(1, nt) = lsl
        p3(2, nt) = lel
        p3(3, nt) = j
      else
        if (linchk(j, lel, l1).ne.0 .or.
     &      linchk(lsl, j, l2).ne.0) return
        nt = nt + 1
        call linadd(j, lel, l1, nt)
        call linadd(lsl, j, l2, nt)
        lp(ll) = nt
        p3(1, nt) = lel
        p3(2, nt) = lsl
        p3(3, nt) = j
        end if
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      function   linchk(p1, p2, l)
      implicit   none
      integer    p1, p2, l, linchk
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      common     /iline/ nl, ls, le, lp, rp
c
      integer    i
c -------------------------------------------------------------------- c
      linchk = 0
      l = 0
      do i = 1, nl
        if (ls(i).eq.p1 .and. le(i).eq.p2) then
          if (rp(i) .eq. 0) then
            l = i
          else
            linchk = -1
            end if
          return
          end if
        if (le(i).eq.p1 .and. ls(i).eq.p2) then
          if (lp(i) .eq. 0) then
            l = -i
          else
            linchk = -1
            end if
          return
          end if
        end do
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine linadd(p1, p2, l, ntw)
      implicit   none
      integer    p1, p2, l, ntw
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      common     /iline/ nl, ls, le, lp, rp
c
      integer    i
c -------------------------------------------------------------------- c
      if (l .eq. 0) then
        nl = nl + 1
        if (nl .gt. ml) then
          write(0, *) '# nl .gt. ml'
          stop
          end if
        ls(nl) = p1
        le(nl) = p2
        rp(nl) = ntw
      else if (l .gt. 0) then
        rp(l) = ntw
      else
        lp(-l) = ntw
        end if
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine linsea
      implicit   none
c
      integer    mp, mr
      parameter  (mp = 7000, mr = 7000)
      integer    np, ip(mp), nin, nr
      real*8     xmin, ymin, xmax, ymax, xp(mp), yp(mp), gp(mp, mr)
      common     /ipoint/ np, ip, nin, nr
      common     /rpoint/ xmin, ymin, xmax, ymax, xp, yp, gp
c
      integer    ml
      parameter  (ml = 1000000)
      integer    nl, ls(ml), le(ml), lp(ml), rp(ml)
      real*8     dlensq, accy
      common     /iline/ nl, ls, le, lp, rp
      common     /rline/ dlensq, accy
c
      integer    i, j, nid(mp)
      real*8     d, xyd(mp)
c -------------------------------------------------------------------- c
      do i = 1, np
        nid(i) = 0
        xyd(i) = 999999999.9d+29
        end do
c
      do i = 1, np-1
        if (mod(i, 1000) .eq. 0) write(0, *) '# linsea point =', i
        do j = i+1, np
          d = (xp(i)-xp(j))*(xp(i)-xp(j))+(yp(i)-yp(j))*(yp(i)-yp(j))
          if (d .lt. xyd(i)) then
            nid(i) = j
            xyd(i) = d
            end if
          if (d .lt. xyd(j)) then
            nid(j) = i
            xyd(j) = d
            end if
          end do
        end do
c
      nl = 0
      do i = 1, np
        if (nid(i) .gt. i) then
          nl = nl + 1
          ls(nl) = i
          le(nl) = nid(i)
        else if (nid(nid(i)) .ne. i) then
          nl = nl + 1
          ls(nl) = i
          le(nl) = nid(i)
          end if
        end do
c
      write(0, *) '# nl =', nl
c -------------------------------------------------------------------- c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine pntred
      implicit   none
c
      integer    mp, mr
      parameter  (mp = 7000, mr = 7000)
      integer    np, ip(mp), nin, nr
      real*8     xmin, ymin, xmax, ymax, xp(mp), yp(mp), gp(mp, mr)
      real*8     dlensq, accy
      common     /ipoint/ np, ip, nin, nr
      common     /rpoint/ xmin, ymin, xmax, ymax, xp, yp, gp
      common     /rline/ dlensq, accy
c
      integer    i, j, k, l, ix, iy, na
      real*8     xpw(3000), ypw(3000), w(3000), x, y, xy, xym
      real*8     xpw2, ypw2, w2
c -------------------------------------------------------------------- c
      np = 1
      do i = 1, mp
        read(5, *, end=1) ip(np), xp(np), yp(np), (gp(np, j), j=1, nr)
        if (i .eq. 1) then
          xmin = xp(np)
          xmax = xp(np)
          ymin = yp(np)
          ymax = yp(np)
        else
          if (xmin .gt. xp(np)) xmin = xp(np)
          if (xmax .lt. xp(np)) xmax = xp(np)
          if (ymin .gt. yp(np)) ymin = yp(np)
          if (ymax .lt. yp(np)) ymax = yp(np)
          end if
        np = np + 1
2       continue
        end do
      write(0, *) '##### data > mp #####'
      stop
1     np = np - 1
c     np = 1000
c
      na = 0
      if (nin .ne. 0) then
        xym = (dmin1(xmax-xmin, ymax-ymin) / dfloat(nin) * 0.5d0) ** 2
        do ix = 0, nin
          do iy = 0, nin
            x = dfloat(ix) / dfloat(nin) * (xmax - xmin) + xmin
            y = dfloat(iy) / dfloat(nin) * (ymax - ymin) + ymin
            do i = 1, np
              xy = (x - xp(i))*(x - xp(i)) + (y - yp(i))*(y - yp(i))
              if (xy .lt. 1.0d0) go to 3
              end do
            na = na + 1
            if (na .gt. 3000 .or. np+na .gt. mp) then
              write(0, *) '##### data + > mp #####'
              stop
              end if
            xpw(na) = x
            ypw(na) = y
            w(na) = rand()
3           continue
            end do
          end do
c
        do i = 2, na
          do j = 1, i-1
            if (w(i) .lt. w(j)) then
              w2 = w(i)
              xpw2 = xpw(i)
              ypw2 = ypw(i)
              do k = i-1, j, -1
                w(k+1) = w(k)
                xpw(k+1) = xpw(k)
                ypw(k+1) = ypw(k)
                end do
              w(j) = w2
              xpw(j) = xpw2
              ypw(j) = ypw2
              go to 4
              end if
            end do
4         continue
          end do
c
        do i = 1, na
          np = np + 1
          ip(np) = -i
          xp(np) = xpw(i)
          yp(np) = ypw(i)
          do j = 1, nr
            gp(np, j) = 0.0
            end do
          end do
c
        end if
c
      write(0, *) '# np, na =', np, na
c -------------------------------------------------------------------- c
      return
      end
