/*
*  Program name:             g_coin  ver. 2.0
*
*  Program function:         JKM grid data coining
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            Jul 31, 1990
*
*  Date of revision:         Sep  8, 1993 by Y. Murata
*                            Jun 18, 1995 rewrite using C by Y. Murata
*                            May 1, 2003 Distribution version by Y. Murata
*
*  Arguments:                1. dotting side ( + or - )
*                            2. coining border
*
*  Input:                    JKM (from stdin)
*
*  Output:                   JKG (to stdout)
*/

#include <stdio.h>
#include <string.h>

int	Nx, Ny ;
double	Xstr, Ystr, Dx, Dy ;
float	Und, Zmin, Zmax, Z ;

main(argc, argv)
int	argc ;
char	*argv[] ;
{
	int	bnds, ix, iy, in, atoi() ;
	char	c ;
	double	x, y, atof() ;
	float	v ;

	bnds = 0 ;
	v = 0.0 ;
	in = 1 ;
	if (argc > 1 && !strcmp(argv[1], "-h")) {
		fprintf(stderr, " USAGE: g_coin {+/- coining-border}\n") ;
		return(0) ;
		}
	if (argc > 1 && argv[1][0] == '+') bnds = 1 ;
	if (argc > 2) v = atof(argv[2]) ;
	if (argc > 3) in = atoi(argv[3]) ;
	while ((c = getchar()) != '\n') if (c == EOF) {
		fprintf(stderr, " Can't read JKM comment.\n") ;
		return(-1) ;
		}
	if (scanf("%d %d %lf %lf %lf %lf %f %f %f",
		&Nx, &Ny, &Xstr, &Ystr, &Dx, &Dy, &Und, &Zmin, &Zmax) != 9) {
		fprintf(stderr, " Can't read JKM header.\n") ;
		return(-1) ;
		}
	for (ix = 0; ix < Nx; ix++) for (iy = 0; iy < Ny; iy++) {
		if (scanf("%f", &Z) != 1) {
			fprintf(stderr, " Can't read JKM data.\n") ;
			return(-1) ;
			}
		if (ix%in != 0 || iy%in != 0) continue ;
		if ((bnds == 0 && Z <= v) || (bnds == 1 && Z >= v)) {
			x = Xstr + (double)ix * Dx ;
			y = Ystr + (double)iy * Dy ;
			printf("m %lf %lf\n", x, y) ;
			printf("l %lf %lf\n", x, y) ;
			}
		}
	return(0) ;
	}
