c ---------------------------------------------------- For grid file - c
      include    'jkm_parm.f'
c -------------------------------------------------- For spline file - c
      integer    mx, my
      real*8     sd, w1, w2, w3, abic
      real*8     xmin, ymin, xmax, ymax, vmin, vwid
      real*8     cij(260, 260), crs(260, 260)
c ------------------------------------------------------ For program - c
      integer    ider, nin, i, j
      real       scale, shift
      real*8     rsmax, xx, yy, xwid, ywid, x0, y0, f, f1, f2
      character  dsn*40
      data       und/99999.0/
c -------------------------------------------------------------------- c
      write(6, *) ' Key-in Spline file name ==>> '
      read(5, '(a40)') dsn
c -------------------------------------------------------------------- c
      write(6, *) ' nx, ny, x0, y0, dx, dy ==>> '
      read(5, *) nx, ny, x0, y0, dx, dy
c -------------------------------------------------------------------- c
      write(6, *)
     &  ' Derivative order ( 0 or 1 or 2 or -1:Est error ) ==>> '
      read(5, *) ider
c -------------------------------------------------------------------- c
      write(6, *) ' Scale, Shift ==>> '
      read(5, *) scale, shift
c -------------------------------------------------------------------- c
      if(ider .ge. 0) then
        write(6, *) ' Maximum Estimation error  ==>> '
        read(5, *) rsmax
        end if
c -------------------------------------------------------------------- c
      open(1, file=dsn)
      rewind 1
      read(1, '(2i5)') mx, my
      read(1, '(6d13.6)') sd, w1, w2, w3, w4, abic
      read(1, '(6f13.4)') xmin, ymin, xmax, ymax, vmin, vwid
      read(1, '(6d13.6)') ((cij(i,j), i=1, mx+3), j=1, my+3),
     &                    ((crs(i,j), i=1, mx+3), j=1, my+3)
      close(1)
c -------------------------------------------------------------------- c
      xwid = xmax - xmin
      ywid = ymax - ymin
c
      if(dx .eq. 0.0) dx = xwid / float(nx-1)
      if(dy .eq. 0.0) dy = ywid / float(ny-1)
c
      if(x0 .eq. -999.0d0 .and. y0 .eq. -999.0d0) then
        x0 = xmin
        y0 = ymin
        end if
c
      xstr = x0
      ystr = y0
c
      x0 = (x0 - xmin) / xwid
      y0 = (y0 - ymin) / ywid
c -------------------------------------------------------------------- c
      do 10 i = 1 , nx
        do 10 j = 1 , ny
          z(i,j) = und
10      continue
c -------------------------------------------------------------------- c
      zmin =  9e9
      zmax = -9e9
      nin = 0
c
      do 20 i = 1 , nx
c
        xx = (float(i-1) * dx) / xwid + x0
        if(xx .lt. 0.0d0 .or. xx .gt. 1.0d0) go to 20
c
        do 30 j = 1 , ny
c
          yy = (float(j-1) * dy) / ywid + y0
          if(yy .lt. 0.0d0 .or. yy .gt. 1.0d0) go to 30
c
          call lsf2f(0.0d0, 0.0d0, 1.0d0, 1.0d0,
     &             mx, my, crs, xx, yy, 0, 0, f)
          f = dsqrt(f) * sd
c
          if(ider .ge. 0) then
            if(f .gt. rsmax) go to 30
            nin = nin + 1
            if(ider .eq. 0) then
              call lsf2f(0.0d0, 0.0d0, 1.0d0, 1.0d0,
     &                 mx, my, cij, xx, yy, ider, ider, f)
              f = f * vwid
            else
              call lsf2f(0.0d0, 0.0d0, 1.0d0, 1.0d0,
     &                 mx, my, cij, xx, yy, ider, 0, f1)
              call lsf2f(0.0d0, 0.0d0, 1.0d0, 1.0d0,
     &                 mx, my, cij, xx, yy, 0, ider, f2)
              f = f1 + f2
              f = f * vwid
              end if
            z(i,j) = (f * vwid + vmin ) * scale + shift
c
          else
            nin = nin + 1
            z(i,j) = f * scale + shift
            end if
c
          if(zmin .gt. z(i,j)) zmin = z(i,j)
          if(zmax .lt. z(i,j)) zmax = z(i,j)
c
30        continue
20      continue
c -------------------------------------------------------------------- c
      write(6, *) nin, '/', nx*ny, ' fill '
c -------------------------------------------------------------------- c
      print '('' Grid file name => '')'
      read(5, '(a40)') dsn
      open(2, file=dsn)
      rewind 2
c
      write(cmnt, '(a14, 6e11.4)') 'sd,w1-w4,abic=', 
     &                       sd, w1, w2, w3, w4, abic
      call grdwtr(2, cmnt, nx, ny, xstr, ystr, dx, dy,
     &        und, zmin, zmax, z)
c
      close(2)
c -------------------------------------------------------------------- c
      stop
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine lsf2f(xmin, ymin, xmax, ymax, mx, my, cij,
     &                 x, y, iderx, idery, f)
c
      real*8     xmin, ymin, xmax, ymax, x, y, f
      integer    mx, my, iderx, idery
      real*8     cij(260,260), bx(4), by(4)
      real*8     hx, hy, rx, ry
      integer    ipx, jpy
c
      hx = (xmax - xmin) / mx
      ipx = int((x - xmin) / hx) + 1
      if(ipx .lt. 1) ipx = 1
      rx = (x - xmin) / hx - ipx + 1
c
      hy = (ymax - ymin) / my
      jpy = int((y - ymin) / hy) + 1
      if(jpy .lt. 1) jpy = 1
      ry = (y - ymin) / hy - jpy + 1
c
      f = 0.0
c
      call bsp3(rx, hx, iderx, bx)
      call bsp3(ry, hy, idery, by)
c
      do 10 i = 0, 3
        do 10 j = 0, 3
c         f = f + cij(ipx+i, jpy+j) * bx(4-i) * by(4-j)
          f = f + cij(ipx+i, jpy+j)*bx(4-i)*by(4-j)*bx(4-i)*by(4-j)
10      continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine bsp3(r, h, ider, bn)
c
      real*8     r, h, bn(4), a, r2, r3
      integer    ider
c
      r2 = r * r
      r3 = r2 * r
c
      if(ider .eq. 2) then
        a = 1.0d0 / (h * h)
        bn(1) = r * a
        bn(2) = (-3.0d0 * r + 1.0d0) * a
        bn(3) = (3.0d0 * r - 2.0d0) * a
        bn(4) = (-r + 1.0d0) * a
c
      else if(ider .eq. 1) then
        a = 0.5d0 / h
        bn(1) = r2 * a
        bn(2) = (-3.0d0 * r2 + 2.0d0 * r + 1.0d0) * a
        bn(3) = (3.0d0 * r2 - 4.0d0 * r) * a
        bn(4) = (-r2 + 2.0d0 * r - 1.0d0) * a
c
      else
        a = 1.0d0 / 6.0d0
        bn(1) = r3 * a
        bn(2) = (3.0d0 * (-r3 + r2 + r) + 1.0d0) * a
        bn(3) = (3.0d0 * r3 - 6.0d0 * r2 + 4.0d0) * a
        bn(4) = (-r3 + 3.0d0 * (r2 - r) + 1.0d0) * a
        end if
c
      return
      end
